Attribute VB_Name = "Module001_GenAllTPI_14V2"
Sub GenAllTPI_14V2()
Attribute GenAllTPI_14V2.VB_Description = "Key: Ctrl+Shift+G\nGenerates AllTIP table\n"
Attribute GenAllTPI_14V2.VB_ProcData.VB_Invoke_Func = "G\n14"
'
'Ctrl+Shift+G   Generates AllTPI sheet using 14 columns of gears
'Predefines the Column number as letters to increase speed ... slightly.
'Deletes all old sheets except sheets starting with uw... such as uwPM1440GT
'Revised Extensively N409 to removed duplicates

'Some Dim Undefined or defined later, but currently working ok
DupQry = False  ' Ask user if he wants to remove the duplicate TPI. True=Remove them
DupFlg = 9999 'Flag for when a duplicate TPI is found
GTestt = True 'Keeps only the first duplicate found between lathe sheet gear Cols t & u
GTestr = True 'Keeps only the first duplicate found between lathe sheet gear Cols r & s
GTestp = True 'Keeps only the first duplicate found between lathe sheet gear Cols p & q
GTesto = True 'Keeps only the first duplicate found between lathe sheet gear Cols o & p
Dim MyLathe As String 'Lathe sheet to use during the generation of TPI table
Dim Test As Long ' used various places
Dim Statusinfo As String
Dim tmpL As String  ' left letter of a string
Dim tmpR As String  ' right letter of a string
'The shorthand for the types is: % -integer; & -long; @ -currency; # -double; ! -single; $ -string
Dim SRow As Long, SCol As Long
Dim RowNum1&, RowNum2&, RowNum3&, RowNum4&, RowNum5&, RowNum6&, RowNum7 As Long
Dim ColNum1&, ColNum2&, ColNum3&, ColNum4&, ColNum5&, ColNum6&, ColNum7&, ColNum8 As Long
Dim ColLet1$, ColLet2$, ColLet3$, ColLet4$, ColLet5$, ColLet6$, ColLet7 As String
Dim MaxCnt As Long  ' check to ensure on error has occurred
Dim WFalse As Long

    MsgStr = "Please provide a Lathe Model Sheet Name.  Examples: uwPM1440GT, uwPM1340GT etc."
        MyLathe = InputBox(MsgStr, _
            "Lathe Sheet Tab Name", "Your Lathe Spread Sheet name goes here")
    If MyLathe = "False" Or Len(Trim(MyLathe)) = 0 Then Exit Sub  'This takes care of CANCEL or Null response
    
    Test = False
    For Each Sheet In ActiveWorkbook.Worksheets  ' this checks for existence of lathe model
        If Sheet.Name = MyLathe Then
            Sheets(MyLathe).Select
            Test = True
            Else
        End If
    Next Sheet

    If Not Test Then
       MsgBox "There is no Lathe Model by the name:  " & MyLathe
        Exit Sub
    End If
    
    DupQry = False
    MsgStr = "This AllTPI Table generation can be with or without duplications of some values. Shall we eliminate the Duplications? "
        YesNoAnswer = MsgBox(MsgStr, vbQuestion + vbYesNo)
        If YesNoAnswer = vbYes Then DupQry = True
       
Application.StatusBar = "Macro Task Initiated First Delete Old sheets and then Create a new one- please wait"
Application.DisplayAlerts = False ' This turns off=False notation of the sheet deletion
'  This deletes all sheets which either do not start with uw
'  i.e. this keeps all "uw" starting and "T" ending sheets
' Currently there are no sheet which end in a "T"

For Each Sheet In ActiveWorkbook.Worksheets
    tmpL = Left(Sheet.Name, 2)
    tmpR = Right(Sheet.Name, 1)
    If tmpL = "uw" Then
        ElseIf tmpR = "T" Then
        Else: Sheet.Delete
    End If
Next Sheet
'Application.DisplayAlerts = True
'
Sheets.Add(Before:=Sheets(1)).Name = "AllTPI" 'create sheet and place at first tab position
Sheets("AllTPI").Select

'First, Get retrieve and place locations for generated data from the MyLathe sheet being used
Sheets(MyLathe).Select
SRow = Cells(1, 1).Value - 1    'Titles at row: 22-1=21
SCol = Cells(2, 1).Value - 1    '2-1 = 1 ==> Column A
RowNum1 = Cells(SRow + 1, SCol + 1).Value '112
RowNum2 = Cells(SRow + 2, SCol + 1).Value '113
RowNum3 = Cells(SRow + 3, SCol + 1).Value '24
RowNum4 = Cells(SRow + 4, SCol + 1).Value '30
'RowNum5 = Cells(SRow + 5, SCol + 1).Value    'TBD if ever needed
'RowNum6 = Cells(SRow + 6, SCol + 1).Value    'TBD if ever needed
RowNum7 = Cells(SRow + 7, SCol + 1).Value  '10 = 'MaxCnt variable to limit the length of a run if need be

ColNum1 = Cells(SRow + 1, SCol + 2).Value '1
ColNum2 = Cells(SRow + 2, SCol + 2).Value '3
ColNum3 = Cells(SRow + 3, SCol + 2).Value '5
ColNum4 = Cells(SRow + 4, SCol + 2).Value '9
ColNum5 = Cells(SRow + 5, SCol + 2).Value '15
ColNum6 = Cells(SRow + 6, SCol + 2).Value '24
ColNum7 = Cells(SRow + 7, SCol + 2).Value '26

ColLet1 = Chr(ColNum1 + 64) '(Chr(1+64)=Chr(65)="A"
ColLet2 = Chr(ColNum2 + 64) '(Chr(3+64)=Chr(67)="C"
ColLet3 = Chr(ColNum3 + 64) '(Chr(5+64)=Chr(69)="E"
ColLet4 = Chr(ColNum4 + 64) '(Chr(9+64)=Chr(73)="I"
ColLet5 = Chr(ColNum5 + 64) '(Chr(15+64)=Chr(79)="O"
ColLet6 = Chr(ColNum6 + 64) '(Chr(24+64)=Chr(88)="X"
ColLet7 = Chr(ColNum7 + 64) '(Chr(26+64)=Chr(90)="Z"

Dim ColNum400&, ColNum401&, ColNum402&, ColNum403&, ColNum404&, ColNum405&, ColNum406&, ColNum407 As Long
Dim ColNum408&, ColNum409&, ColNum410&, ColNum411&, ColNum412&, ColNum413&, ColNum414  As Long
Dim ColLet400$, ColLet401$, ColLet402$, ColLet403$, ColLet404$, ColLet405$, ColLet406, ColLet407 As String
Dim ColLet408$, ColLet409$, ColLet410$, ColLet411$, ColLet412$, ColLet413$, ColLet414 As String
ColNum400 = ColNum4 + 0 '9 via(Chr(9+0)=9
ColNum401 = ColNum4 + 1 '10
ColNum402 = ColNum4 + 2 '11
ColNum403 = ColNum4 + 3 '12
ColNum404 = ColNum4 + 4 '13
ColNum405 = ColNum4 + 5
ColNum406 = ColNum4 + 6
ColNum407 = ColNum4 + 7
ColNum408 = ColNum4 + 8 '17
ColNum409 = ColNum4 + 9 '18
ColNum410 = ColNum4 + 10 '19
ColNum411 = ColNum4 + 11
ColNum412 = ColNum4 + 12
ColNum413 = ColNum4 + 13
ColNum414 = ColNum4 + 14 '23

ColLet400 = Chr(ColNum400 + 64) ' Chr(9+64)="I"
ColLet401 = Chr(ColNum401 + 64) ' "J"
ColLet402 = Chr(ColNum402 + 64) ' "K"
ColLet403 = Chr(ColNum403 + 64)
ColLet404 = Chr(ColNum404 + 64)
ColLet405 = Chr(ColNum405 + 64)
ColLet406 = Chr(ColNum406 + 64)
ColLet407 = Chr(ColNum407 + 64)
ColLet408 = Chr(ColNum408 + 64)
ColLet409 = Chr(ColNum409 + 64)
ColLet410 = Chr(ColNum410 + 64)
ColLet411 = Chr(ColNum411 + 64)
ColLet412 = Chr(ColNum412 + 64)
ColLet413 = Chr(ColNum413 + 64) ' Chr(23+64)="V"
ColLet414 = Chr(ColNum414 + 64) ' Chr(23+64)="W"

' Need a check on the looping to prevent the process from going on too long,i.e. user may have put in too many gears
' The MaxCnt check will be located put inside the loops and increase 8x each time it is rejected by the user
MaxCnt = RowNum7 ' Initial value, but this value will increase if allowed to do so.
If MaxCnt <= 0 Then MaxCnt = 128

'Set the column widths & formats of table being generated
Sheets("AllTPI").Select

'Columns("A:Z").ColumnWidth = 8  ' All columns
Columns(ColLet1 & ":" & ColLet7).ColumnWidth = 8 'works to set column width S based upon MyLathe values
'Columns("A:B").ColumnWidth = 5  'counters at left
Columns(ColLet1 & ":" & Chr(ColNum1 + 64 + 1)).ColumnWidth = 5  ' Row and line numbers
Columns(ColLet4 & ":" & Chr(ColNum6 + 64 - 3)).ColumnWidth = 6 'the gear numbers and knobs

Columns(Chr(ColNum4 + 64 - 1)).ColumnWidth = 6  'The first column in the table could be different
Columns(Chr(ColNum3 + 64 + 2)).Borders(xlEdgeRight).LineStyle = xlDouble 'vertical double line edge at last cell of English data value
Columns(Chr(ColNum6 + 64 - 1)).ColumnWidth = 6  ' The last column in the table could be different
Columns(Chr(ColNum6 + 64 - 2)).Borders(xlEdgeLeft).LineStyle = xlDouble 'vertical double line edge at first cell of Metric data value

Columns(ColLet2 & ":" & ColLet7).NumberFormat = "0.00000"  ' all but the first two column - counters-- then change some back
Columns(Chr(ColNum5 + 64 - 1) & ":" & Chr(ColNum6 + 64 - 3)).NumberFormat = "0" ' the exchange gear columns (teeth, not gear box)
Columns(ColLet1 & ":" & ColLet7).HorizontalAlignment = xlCenter 'center txt for all columns

Range("A2").NumberFormat = "0"  ' upper left corner of table= total number of gear settings generate

' Copy-Paste two header lines, CopyColTitles, from Lathe sheet to AllTPI
Sheets(MyLathe).Select
Range(ColLet1 & RowNum1, ColLet7 & RowNum2).Select  ' select and copy the two title_header rows
Selection.Copy
Worksheets("AllTPI").Select
ActiveSheet.Range("A1").Select  'Home is the first paste entry location for titles
Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
    SkipBlanks:=False, Transpose:=False
Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
    :=False, Transpose:=False
'  Place a double line under the titles
Range("A2", ColLet7 & 2).Borders(xlEdgeBottom).LineStyle = xlDouble

Application.StatusBar = "New Sheet Constructed, now initiating parameters - please wait"

'  More Dim statements here
Dim LineCount As Long, GearRowCnt As Long
LineCount = 4  ' number of rows/lines in the spread sheet of computed data, Initial spread sheet row corresponding to the line count.
GearRowCnt = 1  ' number of rows of data, initial value=1
Sheets(MyLathe).Select
'Use the row numbers where data is temporarily stored at the bottom of MyLathe sheet
Worksheets(MyLathe).Range(ColLet1 & RowNum2 + 1) = LineCount 'bottom of MyLathe sheet
Worksheets(MyLathe).Range(Chr(ColNum1 + 64 + 1) & RowNum2 + 1) = GearRowCnt  ' second column contains the gear row count #

'Dimension some running ranges used to select the gear values at the pull down menus.
'The shorthand for the types is: % -integer; & -long; @ -currency; # -double; ! -single; $ -string
Dim dvCeli As Range, dvCelj As Range, dvCelk As Range, dvCell As Range, dvCelm As Range, dvCeln As Range, dvCelo As Range, dvCelp As Range, dvCelq As Range, dvCelr As Range, dvCels As Range, dvCelt As Range, dvCelu As Range, dvCelv As Range
Dim InputRi As Range, InputRj As Range, InputRk As Range, InputRl As Range, InputRm As Range, InputRn As Range, InputRo As Range, InputRp As Range, InputRq As Range, InputRr As Range, InputRs As Range, InputRt As Range, InputRu As Range, InputRv As Range
Dim Ri As Range, Rj As Range, Rk As Range, Rl As Range, Rm As Range, Rn As Range, Ro As Range, Rp As Range, Rq As Range, Rr As Range, Rs As Range, Rt As Range, Ru As Range, Rv As Range
Dim Ci&, Cj&, Ck&, Cl&, Cm&, Cn&, Co&, Cp&, Cq, Cr&, Cs&, Ct&, Cu&, Cv As Long

Worksheets(MyLathe).Select
' Define values as coming from the pull down menu Locations as ranges:
'Set dvCeli = Worksheets(MyLathe).Range("I30")  ' example Typical
Set dvCeli = Worksheets(MyLathe).Range(Chr(ColNum4 + 0 + 64) & RowNum4)    'I30
Set dvCelj = Worksheets(MyLathe).Range(Chr(ColNum4 + 1 + 64) & RowNum4)    'J30
Set dvCelk = Worksheets(MyLathe).Range(Chr(ColNum4 + 2 + 64) & RowNum4)    'K30
Set dvCell = Worksheets(MyLathe).Range(Chr(ColNum4 + 3 + 64) & RowNum4)    'L30
Set dvCelm = Worksheets(MyLathe).Range(Chr(ColNum4 + 4 + 64) & RowNum4)    'M30
Set dvCeln = Worksheets(MyLathe).Range(Chr(ColNum4 + 5 + 64) & RowNum4)    'N30
Set dvCelo = Worksheets(MyLathe).Range(Chr(ColNum4 + 6 + 64) & RowNum4)    'O30
Set dvCelp = Worksheets(MyLathe).Range(Chr(ColNum4 + 7 + 64) & RowNum4)    'P30
Set dvCelq = Worksheets(MyLathe).Range(Chr(ColNum4 + 8 + 64) & RowNum4)    'Q30
Set dvCelr = Worksheets(MyLathe).Range(Chr(ColNum4 + 9 + 64) & RowNum4)    'R30
Set dvCels = Worksheets(MyLathe).Range(Chr(ColNum4 + 10 + 64) & RowNum4)    'S30
Set dvCelt = Worksheets(MyLathe).Range(Chr(ColNum4 + 11 + 64) & RowNum4)    'T30
Set dvCelu = Worksheets(MyLathe).Range(Chr(ColNum4 + 12 + 64) & RowNum4)    'U30
Set dvCelv = Worksheets(MyLathe).Range(Chr(ColNum4 + 13 + 64) & RowNum4)    'V30
'
' Set Varibles as otained from the pull down formulas in the pull down menu cells
Set InputRi = Evaluate(dvCeli.Validation.Formula1)
Set InputRj = Evaluate(dvCelj.Validation.Formula1)
Set InputRk = Evaluate(dvCelk.Validation.Formula1)
Set InputRl = Evaluate(dvCell.Validation.Formula1)
Set InputRm = Evaluate(dvCelm.Validation.Formula1)
Set InputRn = Evaluate(dvCeln.Validation.Formula1)
Set InputRo = Evaluate(dvCelo.Validation.Formula1)
Set InputRp = Evaluate(dvCelp.Validation.Formula1)
Set InputRq = Evaluate(dvCelq.Validation.Formula1)
Set InputRr = Evaluate(dvCelr.Validation.Formula1)
Set InputRs = Evaluate(dvCels.Validation.Formula1)
Set InputRt = Evaluate(dvCelt.Validation.Formula1)
Set InputRu = Evaluate(dvCelu.Validation.Formula1)
Set InputRv = Evaluate(dvCelv.Validation.Formula1)

' Initialize loop counters indices
Ci = 1
Cj = 1
Ck = 1
Cl = 1
Cm = 1
Cn = 1
Co = 1
Cp = 1
Cq = 1
Cr = 1
Cs = 1
Ct = 1
Cu = 1
Cv = 1
'
' Before looping: Initialize the values in the pull down menus to the first in the list
' It is not clear that this is necessary, but it removes an possible history
'Worksheets(MyLathe).Cells(30, "I").Value = InputRi(1, 1) ' example
Worksheets(MyLathe).Select
Cells(RowNum4, ColNum4 + 0).Value = InputRi(1, 1) '(30,"I")=(30,9+0)
Cells(RowNum4, ColNum4 + 1).Value = InputRj(1, 1)
Cells(RowNum4, ColNum4 + 2).Value = InputRk(1, 1)
Cells(RowNum4, ColNum4 + 3).Value = InputRl(1, 1)
Cells(RowNum4, ColNum4 + 4).Value = InputRm(1, 1)
Cells(RowNum4, ColNum4 + 5).Value = InputRn(1, 1)
Cells(RowNum4, ColNum4 + 6).Value = InputRo(1, 1)
Cells(RowNum4, ColNum4 + 7).Value = InputRp(1, 1)  '(30,"P")=(30,9+7)
Cells(RowNum4, ColNum4 + 8).Value = InputRq(1, 1)
Cells(RowNum4, ColNum4 + 9).Value = InputRr(1, 1)
Cells(RowNum4, ColNum4 + 10).Value = InputRs(1, 1)
Cells(RowNum4, ColNum4 + 11).Value = InputRt(1, 1)
Cells(RowNum4, ColNum4 + 12).Value = InputRu(1, 1)
Cells(RowNum4, ColNum4 + 13).Value = InputRv(1, 1)  '(30,"V")=(30,9+13)=(30,22)

'Concept:  Nested loops for pull down menus, with indexing data count of the number of data Rows: "GearRowCnt".
' Loop until value = "Zzz" for first gear ratio
' Loop until value = "Zzz" for 2nd gear ratio
' Loop until value = "Zzz" for next gear or gear ratio, etc.
' Suggestion: With the exception of the "PQR(I)T" column arrange each column in increasing value and increasing alphabetical value, A, B, C, etc.
' Order the loops below as to how the gears should be incremented in the AllTPI table
' for the PM1440GT chose to use: LScrew-Feed, Doubling (AB-CD)as the outer most loops, followed by the
' order described below in the Specific Description.
' Note: Between the lathe name sheet and the AllTPI sheet there is one column letter difference. The
' AllTPI gear columns are shifted one to the left.
' The current looping order is equivalent to doing a sort of the AllTPI sheet
' of "L+M+U+N+T+S+R+Q+P+O+K+J+I+H+" where the H column of the AllTPI sheet is the equivalent of the I column
' of the Lathe named sheet.  Howevever, Excel only allows sorts on 13 columns so H+ would have to left off
' in the sort of AllTPI.  Hence, when generating the AllTPI sheet sequence #s are placed at the A and B columns
' to allow a sort which restores the originally generated order.  These are known as
' Increment LineCount and GearRowCnt.
' To create the AllTPI sheet layout with LineCounts, TPI values etc. and gears this program organizes
' each of these as a line at the bottom of the Lathe Sheet and then copies and pastes these lines
' into the AllTPI sheet sequentially.  This copy paste process between two sheets would cause a screen
' change back and forth with the required screen refresh.  Hence, the screen refresh is shut off during
' the AllTPI generation to speed things up.  However, at the lower left hand corner of the Excel screen
' a message is displayed showing the generation process.
' Hence LineCount & GearRowCnt in lathe sheet at each row next to a  gear data set a convenience.
'
' SPECIFIC DESCRIPTION .. of Looping Order via the Lathe Sheet column letters.
' The following was set up for the PM1440GT lathe sheet geometrical layouts, but all lathes
' should mimic this layout. However, some columns will be unused: Null (NA) or simply 1.
' In this set of nested loops.  Where, we ...
' Run through each of the gear pull down values and gear box levers in a specific order.
' All Pulldown Menus can be several rows deep and loops exit/stop when encountering the Zzz in the list.
' The list order in the pulldown menus are treated sequentially from top to bottom of the menu
'
' This Program sorts the results with the outer most loop repeating the less frequent.
' However, this looping sequence is defined in this program not by the lathe sheet layout.
' The sequence is a bit different from the lathe sheet geometrical order.  Rather than simply working
' from right hand side to the left of the lathe sheet layout we moved the LS-Feed column, M, to
' the outer most loop.  This puts the Feed values at the bottom of the AllTPI table when the Feed
' values are at the bottom of the pull down menu. Next, col. N, is the 2x multiples, (known
' as AB-CD on the 1440GT).
' By putting the LS-Feed at the outer most loop, and by putting the FEED second on the pull
' down menu list all FEED threading values will be after the TPI values of the Lead Screw.
'
' Next the External Gears change the most slowly i.e. in the outer loops.  The Rigth most column,U,
' Lathe Spindle gears, followed by the left most column, O, Gear box gears.  This allows these two
' gear sets to be paired so that comparisons of them for duplications can be done easily in the
' program code.
'
' After this the axles follow starting with the follow from the right side to the left side of the
' lathe table, specifically the column order U, T, S, R, Q, and P.  Columns U-T, S-R, and Q-P are the
' three interior axles. Most gear box lathes only has the U-T axles and this is where the
' Metric-Imperial, 127/120 gears are placed. By placing these here and in this order allows
' duplicates easily be detected in the program.
'
' Finally the then the gear box levers from right to left generated.  These are the inner most loops.
' and so the values the most rapidly changing in the AllTPI table. I.e. the left hand column of the
' pull down menus in the lathe Sheet is changing the most rapidly of all.
'
' Currently no Duplication removal is performed for the Gearbox levers as this would probably create
' confusion.
'

Application.ScreenUpdating = True  'Show the jump to the Sheet of the Table
Worksheets("AllTPI").Select
Application.ScreenUpdating = False  'If False then the screen does not refresh during execution.  Speed is Much better
Worksheets(MyLathe).Select

Application.StatusBar = "Starting the gear build - please wait"

GTestt = True 'Keeps only the first duplicate found between lathe sheet gear Cols t & u
GTestr = True 'Keeps only the first duplicate found between lathe sheet gear Cols r & s
GTestp = True 'Keeps only the first duplicate found between lathe sheet gear Cols p & q
GTesto = True 'Keeps only the first duplicate found between lathe sheet gear Cols o & p

WFalse = False  'Logic used to get out of the loops if the # of Loops exceeds a preset MaxCnt
Do While WFalse = False  ' This is a conditional function.  Ends with wend

    ' Put the FEED Generated TPI values at the bottom of the table
    For Each Rm In InputRm  ' "m" ==>column M 'Pull down Menu: labeled LS-Feed, So Feed TPI values occur last
        dvCelm = Rm.Value   ' This is the LS-Feed column loop
        If Worksheets(MyLathe).Range(ColLet404 & RowNum4).Value = "Zzz" Then Exit For

    'Factors of 2, AB-CD: Next most outer most loop.  First allow all gears to run
    'through without simply doubling the TPI value.
    For Each Rn In InputRn  ' "n" stands for the N column, Pull down Menu labled: AB-CD
        dvCeln = Rn.Value   ' This is the AB-CD knob loop on the PM1440GT
        If Worksheets(MyLathe).Range(ColLet405 & RowNum4).Value = "Zzz" Then Exit For
 
        ' Now increment the menus for the the rest of the gear box and external gears.
        ' See "SPECIFIC DESCRIPTION" above for the order of the loops.
        ' The last  gear column is the Upper (spindle) Gear loop, the gear that drives the spindle
    
    GTesto = True 'Reset the "o" Duplication test for the o-v axial.
    For Each Rv In InputRv   ' "v" outer most looping group is from column V, the top Spindle gear, Pull down Menu: "Spindle"
        dvCelv = Rv.Value   'Chr(ColNum4 + 13 + 64) ==>(ColLet413 & RowNum4)==> Column "V"
        If Worksheets(MyLathe).Range(ColLet413 & RowNum4).Value = "Zzz" Then Exit For

    For Each Ro In InputRo  ' "o" ==>column O 'Pull down Menu: labled Screw2C
        dvCelo = Ro.Value 'Column "O"  Note next to the V column here
        If DupQry And GTesto = False And Ro.Value = Rv.Value Then dvCelo = DupFlg
        If Worksheets(MyLathe).Range(ColLet406 & RowNum4).Value = "Zzz" Then Exit For

    GTestt = True 'Reset the "t" Duplication test for the t-u axial.
    For Each Ru In InputRu   ' "u" ==>column U, Pull down Menu labeled: A2Spin: Gear Shaft A, 127:120 Exchange Gear
        dvCelu = Ru.Value
        If Worksheets(MyLathe).Range(ColLet412 & RowNum4).Value = "Zzz" Then Exit For

    For Each Rt In InputRt  ' "t" ==>column T 'Pull down Menu: labeled A-A, Gear Shaft A, 127:120 Exchange Gear
        dvCelt = Rt.Value
        If DupQry And GTestt = False And Rt.Value = Ru.Value Then dvCelt = DupFlg
        If Worksheets(MyLathe).Range(ColLet411 & RowNum4).Value = "Zzz" Then Exit For
           
    GTestr = True 'Reset the "r" Duplication test for the r-s axial.
    For Each Rs In InputRs  ' "s" ==>column S 'Pull down Menu: labeled B2A, Gear Shaft B
        dvCels = Rs.Value
        If Worksheets(MyLathe).Range(ColLet410 & RowNum4).Value = "Zzz" Then Exit For

    For Each Rr In InputRr  ' "r" ==>column R 'Pull down Menu: labeled B-B, Gear Shaft B
        dvCelr = Rr.Value
        If DupQry And GTestr = False And Rr.Value = Rs.Value Then dvCelr = DupFlg
        If Worksheets(MyLathe).Range(ColLet409 & RowNum4).Value = "Zzz" Then Exit For

    GTestp = True 'Reset the "p" Duplication test for the p-q axial.
    For Each Rq In InputRq  ' "q" ==>column Q 'Pull down Menu: labled C2B, Gear Shaft C
        dvCelq = Rq.Value
        If Worksheets(MyLathe).Range(ColLet408 & RowNum4).Value = "Zzz" Then Exit For

    For Each Rp In InputRp  ' "p" ==>column P 'Pull down Menu: labeled C-C, Gear Shaft C
        dvCelp = Rp.Value
        If DupQry And GTestp = False And Rp.Value = Rq.Value Then dvCelp = DupFlg
        If Worksheets(MyLathe).Range(ColLet407 & RowNum4).Value = "Zzz" Then Exit For
 
' Finished all of the external gears.
' Now drive the gear box.
'********** Moved A_D knob factors of 2 to second most outer loop, Column N
'********** Moved LS-Feed knob First most outer loop, Column M

    For Each Rl In InputRl  ' "l" ==>column L 'Pull down Menu: labeled NA
        dvCell = Rl.Value   ' This is a Null loop in the PM1440GT
        If Worksheets(MyLathe).Range(ColLet403 & RowNum4).Value = "Zzz" Then Exit For
 
        
    For Each Rk In InputRk  ' "k" ==>column K 'Pull down Menu: labeled NA
        dvCelk = Rk.Value   ' This is a Null loop in the PM1440GT
        If Worksheets(MyLathe).Range(ColLet402 & RowNum4).Value = "Zzz" Then Exit For
        
    For Each Rj In InputRj  ' "j" ==>column J 'Pull down Menu: labeled WXYZ (PM1440GT)
        dvCelj = Rj.Value
        If Worksheets(MyLathe).Range(ColLet401 & RowNum4).Value = "Zzz" Then Exit For
        
    For Each Ri In InputRi  'The PM1440GT PQRiT lever loop.  If a Norton gear box, One, Two, etc.
        dvCeli = Ri.Value  'Inner most looping group is from column I, the first set of gear handles
        If Worksheets(MyLathe).Range(ColLet400 & RowNum4).Value = "Zzz" Then Exit For
' That is all of the gears and levers, but all of the Next (returns) are below, after
' the information is copied to the bottom of the lathe sheet and then to the AllTPI table sheet.
    
    ' Condition to remove Duplicate values from the generated table
    ' 3 Dual Gear Axles (Colmns p, r, t) plus the Spindle-Gearbox Axle pair (Colmn: o)
    If dvCelo = DupFlg Or dvCelt = DupFlg Or dvCelr = DupFlg Or dvCelp = DupFlg Then
    Else   ' required
    
' Organize the gear values into a single row structure at the bottom of the sheet.
    Worksheets(MyLathe).Select
' Worksheets(MyLathe).Cells(112 - 1 + Ci, "I").Value = Worksheets(MyLathe).Range("I28").Value  '(Chr(ColNum4 + 0 + 64) & RowNum4)
    Cells(RowNum2 + Ci, ColNum4 + 0 - 1).Value = Range(ColLet400 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum400).Value = Range(ColLet401 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum401).Value = Range(ColLet402 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum402).Value = Range(ColLet403 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum403).Value = Range(ColLet404 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum404).Value = Range(ColLet405 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum405).Value = Range(ColLet406 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum406).Value = Range(ColLet407 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum407).Value = Range(ColLet408 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum408).Value = Range(ColLet409 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum409).Value = Range(ColLet410 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum410).Value = Range(ColLet411 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum411).Value = Range(ColLet412 & RowNum4).Value
    Cells(RowNum2 + Ci, ColNum412).Value = Range(ColLet413 & RowNum4).Value

'English Cells-- Copy TPI etc 5 rows of data into a single row of 5 columns, transpose, at the bottom of My lathe sheet to lelft of gear values
    Worksheets(MyLathe).Select
    Range(Cells(RowNum3, ColNum3), Cells(RowNum3 + 4, ColNum3)).Select
    Selection.Copy
    ActiveSheet.Range(ColLet2 & RowNum2 + Ci).Select
    Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
        SkipBlanks:=False, Transpose:=True
    Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
        :=False, Transpose:=True

'Metric Cells -- Copy mm/Thread etc 5 rows of data into a singe row of 5 columns, transpose, to right of the with gear values.
    Worksheets(MyLathe).Select
    Range(Cells(RowNum3, ColNum6), Cells(RowNum3 + 4, ColNum6)).Select
    Selection.Copy
    ActiveSheet.Range(Cells(RowNum2 + Ci, ColNum6 - 2), Cells(RowNum2 + Ci, ColNum6 - 2)).Select
' ActiveSheet.Range(ColLet6 & RowNum2 + Ci).Select
    Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
        SkipBlanks:=False, Transpose:=True
    Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
        :=False, Transpose:=True

' Insert a LineCount and GearRowCnt at the left columns of MyLathe.
    Worksheets(MyLathe).Cells(RowNum2 + Ci, ColNum1).Value = LineCount - 1
    Worksheets(MyLathe).Cells(RowNum2 + Ci, ColNum1 + 1).Value = GearRowCnt
    LineCount = LineCount + 1
    GearRowCnt = GearRowCnt + 1

'Copy & Paste the lines for this gear set seltection
    Worksheets(MyLathe).Select
    Range(Cells(RowNum2 + Ci, ColNum1), Cells(RowNum2 + Ci, ColNum7)).Select
    Selection.Copy
    Worksheets("AllTPI").Select
    ActiveSheet.Range("A" & LineCount - 2).Select
    Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
        :=False, Transpose:=False
        
        If DupQry = True Then ' check to see if Duplicates are removed and if so, highlight the single remaining one
            If Range("N" & LineCount - 2) = Range("U" & LineCount - 2) Then
                Range(Cells(LineCount - 2, 14), Cells(LineCount - 2, 14)).Select
                ActiveCell.Value = "N & U"
                'ActiveCell.Interior.ColorIndex = 6
                ActiveCell.Font.FontStyle = "Bold Italic"
                'ActiveCell.Font.ColorIndex = 3
                ActiveCell.Font.Size = 11
                ActiveCell.Font.Underline = xlUnderlineStyleSingle
                Range(Cells(LineCount - 2, 21), Cells(LineCount - 2, 21)).Select
                ActiveCell.Value = "N & U"
                'ActiveCell.Interior.ColorIndex = 6
                ActiveCell.Font.FontStyle = "Bold Italic"
                'ActiveCell.Font.ColorIndex = 3
                ActiveCell.Font.Size = 11
                ActiveCell.Font.Underline = xlUnderlineStyleSingle
            Else
            End If

            If Range("S" & LineCount - 2) = Range("T" & LineCount - 2) Then
                Range(Cells(LineCount - 2, 19), Cells(LineCount - 2, 19)).Select
                ActiveCell.Value = "S & T"
                'ActiveCell.Interior.ColorIndex = 6
                ActiveCell.Font.FontStyle = "Bold Italic"
                'ActiveCell.Font.ColorIndex = 3
                ActiveCell.Font.Size = 11
                ActiveCell.Font.Underline = xlUnderlineStyleSingle
                Range(Cells(LineCount - 2, 20), Cells(LineCount - 2, 20)).Select
                ActiveCell.Value = "S & T"
                'ActiveCell.Interior.ColorIndex = 6
                ActiveCell.Font.FontStyle = "Bold Italic"
                'ActiveCell.Font.ColorIndex = 3
                ActiveCell.Font.Size = 11
                ActiveCell.Font.Underline = xlUnderlineStyleSingle
            Else
            End If

            If Range("Q" & LineCount - 2) = Range("R" & LineCount - 2) Then
                Range(Cells(LineCount - 2, 17), Cells(LineCount - 2, 17)).Select
                ActiveCell.Value = "Q & R"
                'ActiveCell.Interior.ColorIndex = 6
                ActiveCell.Font.FontStyle = "Bold Italic"
                'ActiveCell.Font.ColorIndex = 3
                ActiveCell.Font.Size = 11
                ActiveCell.Font.Underline = xlUnderlineStyleSingle
                Range(Cells(LineCount - 2, 18), Cells(LineCount - 2, 18)).Select
                ActiveCell.Value = "Q & R"
                'ActiveCell.Interior.ColorIndex = 6
                ActiveCell.Font.FontStyle = "Bold Italic"
                'ActiveCell.Font.ColorIndex = 3
                ActiveCell.Font.Size = 11
                ActiveCell.Font.Underline = xlUnderlineStyleSingle
            Else
            End If

            If Range("O" & LineCount - 2) = Range("P" & LineCount - 2) Then
                Range(Cells(LineCount - 2, 15), Cells(LineCount - 2, 15)).Select
                ActiveCell.Value = "O & P"
                'ActiveCell.Interior.ColorIndex = 6
                ActiveCell.Font.FontStyle = "Bold Italic"
                'ActiveCell.Font.ColorIndex = 3
                ActiveCell.Font.Size = 11
                ActiveCell.Font.Underline = xlUnderlineStyleSingle
                Range(Cells(LineCount - 2, 16), Cells(LineCount - 2, 16)).Select
                ActiveCell.Value = "O & P"
                'ActiveCell.Interior.ColorIndex = 6
                ActiveCell.Font.FontStyle = "Bold Italic"
                'ActiveCell.Font.ColorIndex = 3
                ActiveCell.Font.Size = 11
                ActiveCell.Font.Underline = xlUnderlineStyleSingle
            Else
            End If
            
        Else
        End If
    End If
        
        
' Increment the counters for each of the nested loops
        
    Ci = Ci + 1 'Increment the inner most loop
    Next Ri  ' This is the PQRiT PM1440GT lever loop return
    Ci = 1 'reset this counter for any future loop
    
    Cj = Cj + 1
    Next Rj  ' This is the PM1440GT WXYZ lever loop return
    Cj = 1

    Ck = Ck + 1
    Next Rk  ' This is the NA on the PM1440GT
    Ck = 1

    Cl = Cl + 1
    Next Rl  ' This is the second PM1440GT NA loop return
    Cl = 1

    'Lower left hand corner of Excel Display: Let the User know that something is happening
    Statusinfo = CStr(GearRowCnt - 1)
    Statusinfo = "  Looping -- Gears Completed = " + Statusinfo
    Application.StatusBar = Statusinfo
    
    Cp = Cp + 1
    If GTestp = True And Rp.Value = Rq.Value Then GTestp = False
    Next Rp  ' This is the C-C Exchange Gear loop return
    Cp = 1

    'Let the User know that something is happening
    Statusinfo = CStr(GearRowCnt - 1)
    Statusinfo = "  Looping -- Gears Completed  = " + Statusinfo
    Application.StatusBar = Statusinfo

    Cq = Cq + 1
        If GearRowCnt >= MaxCnt Then   ' MaxCnt: opportunity to quit if too many gear options!
        Application.ScreenUpdating = True
            MsgStr = "The # of combinations found is " + CStr(GearRowCnt - 1) + " exceeds " + CStr(MaxCnt) + ". Shall we exit this process?"
            YesNoAnswer = MsgBox(MsgStr, vbQuestion + vbYesNo + vbDefaultButton2, "Quit now")
            If YesNoAnswer = vbYes Then
                WFalse = True
            Exit Do    ' See Do WFalse=....
        Else
            MaxCnt = 8 * MaxCnt
            MaxCnt = IIf(GearRowCnt > MaxCnt * 8, GearRowCnt + MaxCnt, MaxCnt * 8)
        End If
        End If
    Application.ScreenUpdating = False
    Next Rq  ' This is the C2B Gear loop return
    Cq = 1
    
    Cr = Cr + 1
    If GTestr = True And Rr.Value = Rs.Value Then GTestr = False
    Next Rr  ' This is the B-B Exchange Gear loop return
    Cr = 1
    
    Cs = Cs + 1
    Next Rs  ' This is the B2A Exchange Gear loop return
    Cs = 1
 
    Ct = Ct + 1
    If GTestt = True And Rt.Value = Ru.Value Then GTestt = False
    Next Rt ' This is the A-A Exchange Gear loop return
    Ct = 1
    
    Cu = Cu + 1
    Next Ru  ' This is the A2Spin Exchange Gear loop return
    Cu = 1
    
    ' moved Ro here to get it next to Rv
    Co = Co + 1
    If GTesto = True And Ro.Value = Rv.Value Then GTesto = False
    Next Ro  ' This is the Gear Box Gear loop return, Column O
    Co = 1
   
    Cv = Cv + 1
    Next Rv  ' This is the Spindle Gear loop return
    Cv = 1
   
    '******** Gear box factors of 2x, PM1440GT A_D placed here as second most outer loop
    Cn = Cn + 1
    Next Rn  ' This is the A-D knob loop return
    Cn = 1

    '********* LeadScrew/Feed sequence, column M: outer most loop
    Cm = Cm + 1
    Next Rm  ' This is the LS-Feed knob and lever loop return
    Cm = 1

WFalse = True ' Used above via MaxCnt to allow the User to stop processing. True also exits here.
Exit Do ' Redundant,  out of the over all loop after one trip through
Loop '  Do While condition loop.  Only one loop but needed to allow user to exit

'Application.ScreenUpdating = True  'If false then the screen does not flash during execution.
'Cleaning up the MyLathe Gear Setting to the top of the pull down menu list
'Worksheets(MyLathe).Cells(30, "I").Value = ""  'Alternative
'Put the pull down menus back to the initial value in the list:
Worksheets(MyLathe).Select
Cells(RowNum4, ColNum4 + 0).Value = InputRi(1, 1) '(30,"I")=(30,9)
Cells(RowNum4, ColNum4 + 1).Value = InputRj(1, 1)
Cells(RowNum4, ColNum4 + 2).Value = InputRk(1, 1)
Cells(RowNum4, ColNum4 + 3).Value = InputRl(1, 1)
Cells(RowNum4, ColNum4 + 4).Value = InputRm(1, 1)
Cells(RowNum4, ColNum4 + 5).Value = InputRn(1, 1)
Cells(RowNum4, ColNum4 + 6).Value = InputRo(1, 1)
Cells(RowNum4, ColNum4 + 7).Value = InputRp(1, 1)  '(30,"P")=(30,9+7)
Cells(RowNum4, ColNum4 + 8).Value = InputRq(1, 1)
Cells(RowNum4, ColNum4 + 9).Value = InputRr(1, 1)
Cells(RowNum4, ColNum4 + 10).Value = InputRs(1, 1)
Cells(RowNum4, ColNum4 + 11).Value = InputRt(1, 1) '(30,"T")=(30,9+11)
Cells(RowNum4, ColNum4 + 12).Value = InputRu(1, 1)
Cells(RowNum4, ColNum4 + 13).Value = InputRv(1, 1)

'Range(ColLet411 & RowNum4).Value = 9999 'debug
    
'Insert Row Bottom demarcation lines ~ at the end of each set of gears or every few lines
Worksheets("AllTPI").Select
Application.DisplayAlerts = True
Application.ScreenUpdating = True

Dim RnumSpace As String
Dim Rnum As Long
Dim lRow As Long
Dim lCol As Long
MsgStr = "Shall we insert eye guiding underlines in the TPI table or added them later?  Repeat spacing integer, example: 4, 7,   0=> No Underlines.  "
    RnumSpace = InputBox(MsgStr, _
        "Provide underline spacing number", "0")
If RnumSpace = "False" Or Len(Trim(RnumSpace)) = 0 Then RnumSpace = 0    'This takes care of CANCEL or Null response

Application.ScreenUpdating = False   ' Turns the display off while drawing horizontal lines, saves time.
If RnumSpace <> 0 Then
    'Find the last non-blank cell in TPI column
    lRow = Cells(Rows.Count, 3).End(xlUp).Row
    'Find the last non-blank cell in lRow just found
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
    Rnum = 2 + RnumSpace
    Do While Rnum < GearRowCnt
        With Worksheets("AllTPI").Range(Cells(Rnum, 1), Cells(Rnum, lCol)).Borders(xlEdgeBottom)
            .LineStyle = xlContinuous
            .Weight = xlMedium
            .ColorIndex = 0
        End With
        Rnum = Rnum + RnumSpace  ' Cell bottom demarcation lines + interval at the end of each set of gears
    Loop
Else
End If
' Reposition the Lathe sheet display region to gear functions.
Application.CutCopyMode = False  ' De-selects the last copy/paste range used.
Application.ScreenUpdating = True  ' Turns the display update on so screen reposition move happens
Worksheets(MyLathe).Select
Cells(20, 8).Select  ' move the cursor/screen to middle of the lathe sheet to reposition it

Sheets("AllTPI").Select 'Retrun to AllTPI sheet
Application.DisplayAlerts = True  ' Turns the display update on to show the final results
' Let the User know that something is happening via the Status line
Statusinfo = CStr(GearRowCnt - 1) ' The total number of gear rows generated as String.
Statusinfo = "Macro Task Completed-- Total Gears Completed = " + Statusinfo
Application.StatusBar = Statusinfo
Cells(1, 2) = GearRowCnt - 1 ' Write the total # rows at the top of the AllTPI table
Cells(1, 1).Select  ' move the cursor to the home position.
End Sub
