Attribute VB_Name = "Module002_HideAuto"
Sub HideAuto()
Attribute HideAuto.VB_Description = "Key: Ctrl+Shift+H\nHides columns automatically in the AllTPI sheet. Unused gear columns."
Attribute HideAuto.VB_ProcData.VB_Invoke_Func = "H\n14"

' Purpose to automatically hide columns of a table which are simply repeating entries.
' KeyStroke: Ctrl+Shift+H
' Private Subs used:
' Private Sub FindAutoHideColsX(ShSearch, StartRow, lRow, lCol, HideLetters)
' Private Sub FindFlagAddressX(ShName, SrchCol2, FLAG, LastFlagAddress)
' Private Sub CheckSheetX(ShSearch, ExitSub)

Dim ShSearch As String
Dim SrchCol As String
Dim FLAG As String
Dim LastFlagAddress As String
Dim StartRow As Long
Dim lRow As Long
Dim lCol As Long
Dim HideLetters As String

'Need to insert Chk4ShX etc

'ShSearch, StartRow, lRow, lCol, HideLetters

ShSearch = "AllTPI"
Sheets(ShSearch).Select
SrchCol = "B"
FLAG = "DELETE FLAG"

Call FindFlagAddressX(ShSearch, SrchCol, FLAG, LastFlagAddress)

Sheets(ShSearch).Select ' just in case it was changed in the Call
If LastFlagAddress = "None" Then LastFlagAddress = "A0"
InputStrAft1Let = Right(LastFlagAddress, Len(LastFlagAddress) - 1)
StartRow = InputStrAft1Let + 3

lRow = Cells(Rows.Count, "C").End(xlUp).Row
lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column

Call FindAutoHideColsX(ShSearch, StartRow, lRow, lCol, HideLetters)
Range("AB2") = HideLetters
Range("AB1") = "HideLetters:"

Call Hide_N_Col_AllTPI_X(ShSearch, HideLetters)

End Sub

'***********************************************
'***********************************************
Private Sub FindAutoHideColsX(ShSearch, StartRow, lRow, lCol, HideLetters)
' Looks at content of columns and determines which columns can be hidden without loosing any info

Dim StudyRng As Range
'Dim b As Range
'where As Range
'whatt As String
Dim rngToSearch As Range
Dim str2Srch4 As String
Dim rngResult As Long ' big integers

Sheets(ShSearch).Select
Set StudyRng = Range(Cells(StartRow, 1), Cells(StartRow + lRow, lCol))

HideLetters = ""
CCol = 1
Do While CCol <= lCol + 3 '21 'lCol
    str2Srch4 = Cells(StartRow, CCol).Value
    If Not str2Srch4 <> "" Then Exit Do
    Set rngToSearch = Sheets(ShSearch).Range(Cells(StartRow, CCol), Cells(lRow, CCol))
    rngResult = WorksheetFunction.CountIf(rngToSearch, str2Srch4)
    If rngResult > lRow - StartRow + 0 Then HideLetters = HideLetters & Chr(CCol + 64)
    CCol = CCol + 1
Loop

End Sub
'***********************************************
'***********************************************
Private Sub FindFlagAddressX(ShName, SrchCol2, FLAG, LastFlagAddress)

'This works Great.  If finds the address of the last occurance of
'the "DELETE FLAG"
'Nice and short code to yield the cell address

Dim ColRng As Range, where As Range, whatt As String
Sheets(ShName).Select
whatt = FLAG
Set ColRng = Range(SrchCol2 & ":" & SrchCol2)
Set where = ColRng.Find(What:=whatt, after:=ColRng(ColRng.Cells.Count), searchdirection:=xlPrevious)
If Not where Is Nothing Then
    LastFlagAddress = where.Address(0, 0)
Else
    LastFlagAddress = "None"
Exit Sub
End If

End Sub

'***********************************************
'***********************************************
Private Sub Hide_N_Col_AllTPI_X(ShSearch, HideLetters)
'
'Hides the Columns corresponding to the letter list info
Dim HideColLet As String
Dim LatheName As String
Dim PropHideList As String
Dim ColNum As Long

Call CheckSheetX(ShSearch, ExitSub) ' Check: Sheet name exists? If not, exits with a message
If ExitSub Then Exit Sub

'Sheets(ShSearch).Select
'LatheSheetName = Cells(1, 8) 'Retrive the lathe sheet name from the ALLTPI table title
'Sheets(LatheSheetName).Select
'PropHideList = Cells(6, 1) ' At the lathe sheet find unused Col letters of ALLTPI
'Sheets(ShSearch).Select

HideColLet = HideLetters
Sheets(ShSearch).Select
'MsgStr = "Please list the AllTPI sheet Column LETTERs (A through Z) that you wish to Hide. Example AJK will hide these 3 columns. The Default letters listed below are taken from Cell A6 of the LatheSheet shown in the AllTPI titles.  You may change this Default expression at the LatheSheet."
    'HideColLet = InputBox(MsgStr, _
    '"Column LETTERs to be Hidden", PropHideList)
    If HideColLet = "False" Or Len(Trim(HideColLet)) = 0 Then Exit Sub  'This takes care of CANCEL or Null response
        If HideColLet <> "NONE" Then  'Hide Nothing!
            For ColNum = 1 To Len(HideColLet) Step 1
                ColLet = Mid(HideColLet, ColNum, 1)
                Columns(ColLet & ":" & ColLet).Select
                Selection.EntireColumn.Hidden = True
            Next
    Else
    End If
    
'Sheets(LatheSheetName).Select
'Cells(6, 2) = HideColLet ' At the lathe sheet find unused Col letters of ALLTPI
'Sheets(ShSearch).Select
  
Range("A1").Select ' Put the cursor back to Home
End Sub
'***********************************************
'***********************************************
Private Sub CheckSheetX(ShSearch, ExitSub)
'
' Determines if a sheet exists.
ExitSub = False
YesNoAnswer = 0
For Each Sheet In ActiveWorkbook.Worksheets
    If Sheet.Name = ShSearch Then
        YesNoAnswer = 1
        Exit For
    Else
    End If
    Next
If YesNoAnswer = 0 Then
    MsgStr = "There is no " + ShSearch + " sheet to Search, Please run: GenAllTPI"
    MsgBox MsgStr, vbOKOnly, "Missing Sheet"
    ExitSub = True
Else
End If ' Message regarding missing AllTPI ends
End Sub
