Attribute VB_Name = "Module002_Hide_N_Col_AllTPI"
Sub Hide_N_Col_AllTPI()
Attribute Hide_N_Col_AllTPI.VB_Description = "Key: Ctrl+Shift+N\nHide N columns in the AllTPI sheet.  \nN is a number of columns defined by the user.  "
Attribute Hide_N_Col_AllTPI.VB_ProcData.VB_Invoke_Func = "N\n14"
'
' Key Stroke Ctrl+Shift+N
' Will Hide N columns as provided by the User.  Extracts a Proposed List of Columns via the LatheSheet name in AllTPI
' Uses Private Sub CheckSheetX(ShSearch, ExitSub)
Dim HideColLet As String
Dim LatheName As String
Dim PropHideList As String
Dim ColNum As Long

ShSearch = "AllTPI"
Call CheckSheetX(ShSearch, ExitSub) ' Check: Sheet name exists? If not, exits with a message
If ExitSub Then Exit Sub
Sheets(ShSearch).Select
LatheSheetName = Cells(1, 8) 'Retrive the lathe sheet name from the ALLTPI table title
Sheets(LatheSheetName).Select
PropHideList = Cells(6, 1) ' At the lathe sheet find unused Col letters of ALLTPI
Sheets(ShSearch).Select

HideColLet = "NONE"  ' Default value
Sheets(ShSearch).Select
MsgStr = "Please list the AllTPI sheet Column LETTERs (A through Z) that you wish to Hide. Example AJK will hide these 3 columns. The Default letters listed below are taken from Cell A6 of the LatheSheet shown in the AllTPI titles.  You may change this Default expression at the LatheSheet."
    HideColLet = InputBox(MsgStr, _
    "Column LETTERs to be Hidden", PropHideList)
    If HideColLet = "False" Or Len(Trim(HideColLet)) = 0 Then Exit Sub  'This takes care of CANCEL or Null response
        If HideColLet <> "NONE" Then  'Hide Nothing!
            For ColNum = 1 To Len(HideColLet) Step 1
                ColLet = Mid(HideColLet, ColNum, 1)
                Columns(ColLet & ":" & ColLet).Select
                Selection.EntireColumn.Hidden = True
            Next
    Else
    End If
    
Sheets(LatheSheetName).Select
Cells(6, 2) = HideColLet ' At the lathe sheet find unwanted Col letters of ALLTPI
Sheets(ShSearch).Select
  
Range("A1").Select ' Put the cursor back to Home
End Sub

Private Sub CheckSheetX(ShSearch, ExitSub)
'
ExitSub = False
YesNoAnswer = 0
For Each Sheet In ActiveWorkbook.Worksheets
    If Sheet.Name = ShSearch Then
        YesNoAnswer = 1
        Exit For
    Else
    End If
    Next
If YesNoAnswer = 0 Then
    MsgStr = "There is no " + ShSearch + " sheet to Search, Please run: GenAllTPI"
    MsgBox MsgStr, vbOKOnly, "Missing Sheet"
    ExitSub = True
Else
End If ' Message regarding missing AllTPI ends
'
End Sub

