Attribute VB_Name = "Module003_Srch_Any_Aprox"
Sub Srch_Any_Aprox()
Attribute Srch_Any_Aprox.VB_Description = "Key: Ctrl+Shift+A\nANY column to Search for a value in the AllTPI table."
Attribute Srch_Any_Aprox.VB_ProcData.VB_Invoke_Func = "A\n14"

' N424_1516  works,
' Short Cut Key: Ctrl+Shift+A
' Searches for values in the AllTPI table, Any Column, Any input format, Any Wild Cards, Wild card searches
'     ABOVE AND BELOW (unusual) the input value.

' Calls:
' Private Sub CheckSheetX(ShName, ExitSub)
' Private Sub Cnvt_TPI_2_AproxX(SrchTPI, SrchTPIxUp, SrchTPIxDn)

' Supports ANY column including C, TPI, V, mmPT, of sheet AllTPI
' The search supports wild cards or an exact x.xxxxx style number
' Then high lites what is found and places a copy of that row at the top of the "AllITP" sheet.

    Dim SrchByCol As String
    Dim ShName As String
    Dim ExitSub As Boolean
    Dim Xf As Long ' to be the found column number
    Dim Yf As Long  ' to be the found row number
    Dim ShSearch As String  ' User Input: The sheet to be searched
    Dim lRow As Long ' last row number of the data
    Dim lCol As Long ' last column number of the data
    Dim lColi As Long 'the number of columns in the virgin AllTPI
    Dim TPIRangeCol3 As Range  ' range of actual data in column 3
    Dim AllDataRange As Range  ' range of actual data in sheet
    Dim TPIsrch As String  ' the TIP to be searched for, input from the user msgbox
    Dim MsgStr As String  ' long message box string to the user
    Dim Totaln As Long  ' A counter of the search results
    Dim rFirst As Range
    Dim r As Range
    Dim A As Range
    Dim MyString As String
    Dim Copyn As Long
    Dim CopyRow As Long
    Dim DeleteFlagCnt As Long
    Dim DeleteFlagNum As Long
    Dim TotalDeleteRowCnt As Long
    Dim YesNoAnswer As Integer
    Dim TotalDELETEFLAGRows As Long
    Dim SrchColLet As String  ' the Column to be searched, input via user msgbox
    Dim SrchColNum As Long ' the Column # to be searched, converted from Letter
    
    '****************************************
    ShSearch = "AllTPI"
    ShName = ShSearch
    Call CheckSheetX(ShName, ExitSub) 'Check see if sheet exists
    If ExitSub Then Exit Sub

    '****************************************
    Sheets(ShSearch).Select ' Delete or keep previous searches and count the previous search rows
    
    lRow = Cells(Rows.Count, "C").End(xlUp).Row
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
    lColi = lCol   'The initial Column Count
'count the number of DELETE FLAG s found. If any keep The previous searches???
    TotalDeleteRowCnt = 0
    YesNoAnswer = vbNo
    KeepSrchs = YesNoAnswer
    DeleteFlagCnt = Application.WorksheetFunction.CountIf(Range(Cells(1, 2), Cells(lRow, 2)), "DELETE FLAG")
    If DeleteFlagCnt > 0 Then
        MsgStr = "There has been " + CStr(DeleteFlagCnt) + " previous search(s).  Do you wish to keep them?"
        YesNoAnswer = MsgBox(MsgStr, vbQuestion + vbYesNo + vbDefaultButton2, "Keep Previous Searches")
        KeepSrchs = YesNoAnswer
    End If

    Dim DELrng As Range
    Dim where As Range
    'Sheets(ShSearch).Select
    FLAG = "DELETE FLAG"
    SrchCol = "B"
    Set DELrng = Range(SrchCol & ":" & SrchCol)
    'Set DELrng = Range("B" & ":" & "B")
    Set where = DELrng.Find(What:=FLAG, after:=DELrng(DELrng.Cells.Count), searchdirection:=xlPrevious)
    If Not where Is Nothing Then
        LastFlagAddress = where.Address(0, 0)
        LastFlagRow = Split(where.Address, "$")(2)
    Else
        LastFlagAddress = "None"
        LastFlagRow = 0
    End If
    'Range("AD1") = LastFlagAddress 'debug
    'Range("AD2") = LastFlagRow 'debug
    TotalDeleteRowCnt = LastFlagRow

    If LastFlagRow > 0 And KeepSrchs = vbNo Then
        Range(Rows(1), Rows(LastFlagRow)).Select
        Selection.EntireRow.Delete  'Deletes entire range
    Else
    End If
    Range("A1").Select

'************** Done with DELETE FLAG searching, counting and deleting if needed.


'***********************  Search Column is Requested
    MsgStr = "Please Type ANY Column letter you wish to search:  Example: C for IMPERIAL TPI Values or V for METRIC."
        SrchColLet = InputBox(MsgStr, _
            "Search Column Letter", "C")

'Confirm a Column Letter and if not upper case convert to number then upper case
    If SrchColLet = "False" Or Len(Trim(SrchColLet)) = 0 Then 'This takes care of CANCEL or Null response
        MsgBox ("Search Column letter is invalid-1")
        Exit Sub
    End If
    If Not ((Asc(SrchColLet) < 123 And Asc(SrchColLet) > 96) Or (Asc(SrchColLet) < 91 And Asc(SrchColLet) > 64)) Then  ' if not lower or upper case letter, exit
        MsgBox ("Search Column letter is invalid-2")
        Exit Sub
    End If

    SrchColNum = Asc(SrchColLet) - 64 ' converts to a number if Upper case, but if lower case ...
    If Asc(SrchColLet) > 96 And Asc(SrchColLet) < 123 Then 'if lower case letter convert to upper case
        SrchColNum = Asc(SrchColLet) - (96)  ' column number, converts from lower case to upper case
        SrchColLet = Chr(SrchColNum)  'New Upper case column letter
    Else
    End If

'************************************************************
'*****Cleaning up previous searchs via deletions   ************
'********************************************************

'Start search for TPI
    Range("A1").Select
'Find the last non-blank cell in column 3
    lRow = Cells(Rows.Count, 3).End(xlUp).Row
    
'Find the last column non-blank cell in row lRow.  If the cell has been used before it will not be blank as it
' will have hidden control characters.  To remove control characters used c.Clear or delete several scratch pad columns
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
 
'    Set AllDataRange = Application.Range(Cell1:="A3", Cell2:=Cells(lRow, lCol))
' Clear font color, font style, cell color of previous searches for the range after the last DELETE FLAG and table titles
If KeepSrchs = vbYes Then  ' i.e. Yes, save previous searches, remove the previous searches colors etc. in the main part of the table
'    Set TPIRangeCol22 = Application.Range(Cell1:=Cells(TotalDeleteRowCnt + 3, SrchColNum), Cell2:=Cells(lRow, SrchColNum))
    Set TPIRangeCol22 = Application.Range(Cell1:=Cells(TotalDeleteRowCnt + 3, 1), Cell2:=Cells(lRow, lCol))
    TPIRangeCol22.Font.Color = RGB(0, 0, 0) ' make colum 3 font data black, removes previous search color
    TPIRangeCol22.Interior.Color = RGB(255, 255, 255) ' make colum 3 clear fill, removes previous search color
    TPIRangeCol22.Font.FontStyle = "Normal" 'Clears font stytle from "Bold Italic"
Else   ' NO, so no top rows from searches as they were deleted.  rest color etc of the main table but starting row is now 3
'    Set TPIRangeCol22 = Application.Range(Cell1:=Cells(3, 3), Cell2:=Cells(lRow, 3))
    Set TPIRangeCol22 = Application.Range(Cell1:=Cells(3, 1), Cell2:=Cells(lRow, lCol))
    TPIRangeCol22.Font.Color = RGB(0, 0, 0) ' make colum 3 font data black, removes previous search color
    TPIRangeCol22.Interior.Color = RGB(255, 255, 255) ' make colum 3 clear fill, removes previous search color
    TPIRangeCol22.Font.FontStyle = "Normal" 'Clears font stytle from "Bold Italic"
End If


' Need to change this message when wild cards are added.
' maybe new 'Private Sub Srch_Any_ColX(TPIvalue, ColLetter, SrchShName, KeepSrches, Totalnx)
' also remove/change some of the TPIsrch formating if statements..... See Sub SrchListTPIwWC approach.
'Message providing the search criterial
    MsgStr = "Please Replace w/ the desired VALUE. AllTPI Table values are treated as TEXT in the format of *??.????? " + _
    "This search supports EXACT strings or numbers with or without decimal points such as 13, 13. 13.00 or 13.00000," + _
        " will all yield a search for the integer 13.00000.  It also supports Wild cards * or ?" + _
        "which will yield + and - approximations to the value requested about the wild card." + _
        " For example use  13.0? or 13.0* to yield both 13.00000, 13.02345, 12.99452 ." + _
        " If you want them ordered differently run the sorting macro first."
        TPIsrch = InputBox(MsgStr, _
            "Search For YOUR Desired VALUE", "Your Value Goes Here")
        
'    Range("Y1") = TPIsrch       ' debug
'    Range("Y2") = Len(TPIsrch)  ' debug
    
    nFail = False
'   'If Len(TextBox1) = 0 Then
    If Len(TPIsrch) = Len("Your Number Goes Here") Then
        MsgBox "Search Variable has not been Provided Properly."
        nFail = True
        'Range("Y1") = "nStop = True"
    ElseIf Len(TPIsrch) = Len("") Then
        MsgBox "Search Variable has not been Provided Properly."
        nFail = True
        'Range("Y1") = "nStop = True"
    ElseIf Len(TPIsrch) = Len(" ") Then
        MsgBox "Search Variable has not been Provided Properly."
        nFail = True
        'Range("Y1") = "nStop = True"
    'ElseIf InStr(1, TPIsrch, ".", 1) = 0 Then  'No longer requires input to have a decimal point.
        'MsgBox "Search Variable has not been Provided Properly."
        'nFail = True
    Else
    End If
 '************* call Private Sub to create approximation both + and -
Call Cnvt_TPI_2_AproxX(TPIsrch, SrchTPIxUp, SrchTPIxDn)
'Sheets(ShSearch).Select
Sheets("AllTPI").Select
TempTPIsrch = TPIsrch
NumTimes = 1
If SrchTPIxDn <> "Zzz" Then NumTimes = 2
TPIsrch = SrchTPIxUp
Do While NumTimes > 0

'Range("Z1")=SrchColNum 'debug
'  Could probably clean/simplify this section of code. It is searching the table for the TPIsrch value.
'  Then it also changes the color etc for the table below the Searches.  It is complex and we could simply use
'   TotalDeleteRowCnt = LastFlagRow as the first cell of the range and something like    lRow - DeleteRowCnt +-3 to define the
' last row of the count. However, it is avoiding the title rows TPIsrch ??

    Set A = Range(Cells(TotalDeleteRowCnt + 3, SrchColNum), Cells(lRow, SrchColNum)) 'only search from below the last DELETE FLAG row
    MyString = "  "
    Totaln = 0

    Do
        If nFail Then Exit Do  ' just checking
   
        If rFirst Is Nothing Then
         'Set rFirst = A.Find(What:=TPIsrch, After:=A(1))
            Set rFirst = A.Find(What:=TPIsrch, after:=A(1), lookat:=xlWhole)
            If rFirst Is Nothing Then Exit Do  'Finally this works when the data does not match anything
                Set r = rFirst
            Else
'               'Set r = A.Find(What:=TPIsrch, After:=r)
                Set r = A.Find(What:=TPIsrch, after:=r, lookat:=xlWhole)
                If r.Address = rFirst.Address Then Exit Do
            End If
        Totaln = Totaln + 1
        MyString = MyString & "  " & r.Offset(0, -2)
             
'***********************
        Xf = r.Column  'r is a range, this command finds the first Row of that range, the found value
        Yf = r.Row      ''r is a range, this command finds the first Column of that range
        
        ' this is a scratch pad location, stores the found value's row number, which is needed for copy-paste of row
        Cells(Totaln, lColi + 7) = r.Row
        Cells(Yf, Xf).Select
        ActiveCell.Interior.ColorIndex = 6
        ActiveCell.Font.FontStyle = "Bold Italic"
        ActiveCell.Font.ColorIndex = 3
               
    Loop
    '****************************

    If nFail Then
        'MsgBox "You entered no number!"
    Else ' Messages the results, comment out
        TotalinfoString = "Total number of Results = " + CStr(Totaln)
        'MsgBox TotalinfoString
        If Totaln <> 0 Then  ' Messages a list of the results
            MyString = "Results Found at Row #'s:   " + MyString
            'MsgBox MyString
        Else
        End If
    End If

' Insert some rows
    Range("A1").Select  ' move back to the top of the page.
    If Not nFail Then
        If Not nStop Then
            If Not rFirst Is Nothing Then
                Range("A1:A" & Totaln + 2 + 1).EntireRow.Insert
                Range("B" & Totaln + 2 + 1) = "DELETE FLAG"
'                Range("D" & Totaln + 2 + 1) = Totaln + 2 + 1
                Range("D" & Totaln + 2 + 1) = Totaln
                Range("F" & Totaln + 2 + 1) = " = Total No. of Search Results"
' select and copy the titles
                Range("A1").Select  ' move back to the top of the page.
                Range(Cells(Totaln + 2 + 2, 1), Cells(Totaln + 3 + 2, lCol)).Select
                Selection.Copy
' Paste the titles in
                Range("A1").Select  ' move back to the top of the page.
' paste in the titles
                Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
                    SkipBlanks:=False, Transpose:=False
                Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
                    :=False, Transpose:=False
                Range("A3").Select
                Copyn = 1
                Do While Copyn <= Totaln
                    CopyRow = Cells(Totaln + 2 + 1 + Copyn, lColi + 7).Value
'Range(Cells(Totaln + 5+ Range("X"& Totaln+5, 1)).Select
                    Range(Cells(CopyRow + Totaln + 2 + 1, 1), Cells(CopyRow + Totaln + 2 + 1, lCol)).Select
                    Selection.Copy   ' copy and paste the found data in the new space at the top
                    Cells(Copyn + 2, 1).Select
                    Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
                        SkipBlanks:=False, Transpose:=False
                    Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
                        :=False, Transpose:=False

                    Copyn = Copyn + 1
                   'Range("W1") = CopyRow  ' used for debugging
                   'Range ("X1")=Totaln    ' used for debugging

                Loop
                Range("A1").Select
                Else
            End If
        End If
    End If

'*****************************************
    '  Could eliminate this scratch pad by defining range variables and using the values inserted into the range.
    '      then nothing would be writtn on the spread sheet.
    ' Delete a few columns at right to clean up the scrach pad area and to make the new last column a Null value.
    I = 1
    imax = 8
    Columns(lColi + 1 + imax).EntireColumn.Insert
    While I <= imax + 1
        Columns(lColi + 1).EntireColumn.Delete
        I = I + 1
    Wend
    Range("A1").Select  ' Place cursor at the top left and stop
'********************************
'    Range("I1") = SrchColLet   'debug or allows one to see the sort requested moved this to the subroutine ending lines to prevent rewriting
'    Range("J1") = Asc(SrchColLet) - 64 'Debug info

Set rFirst = Nothing
Set r = Nothing
NumTimes = NumTimes - 1
TPIsrch = SrchTPIxDn
Loop

End Sub

'*************************************
'*************************************

Private Sub CheckSheetX(ShName, ExitSub)
' Need to clean up
'Xitsub to replace ExitSub, poor phrase and is confusing with Exit Sub action
'replace YesNoAnswer

ExitSub = False
YesNoAnswer = 0
For Each Sheet In ActiveWorkbook.Worksheets
    If Sheet.Name = ShName Then
        YesNoAnswer = 1
        Exit For
    Else
    End If
    Next
If YesNoAnswer = 0 Then
    MsgStr = "There is no " + ShName + " sheet"
    MsgBox MsgStr, vbOKOnly, "Missing Sheet"
    ExitSub = True
Else
End If ' Message regarding missing AllTPI ends
'
End Sub
'************************************************************
'************************************************************
Private Sub Cnvt_TPI_2_AproxX(SrchTPI, SrchTPIxUp, SrchTPIxDn)
'Private Sub Cnvt_TPI_2_AproxX2(SrchTPI, SrchTPIxUp, SrchTPIxDn)

' Note that SrchTPI is from a msgbox input so is initially a string.
        If InStr(1, SrchTPI, "+", 1) Or InStr(1, SrchTPI, "-", 1) Then SrchTPI = CStr(Right(SrchTPI, Len(SrchTPI) - 1))
        If InStr(1, SrchTPI, ".", 1) = 1 Then SrchTPI = "0" & SrchTPI   'Add if missing front 0,  0.xxx rather than .xxx

InputVar = SrchTPI
InputStr = InputVar
SrchTPIxUp = "Zzz"
SrchTPIxDn = "Zzz"

' Find the location of some characters
DecPtLoc = InStr(1, InputVar, ".", 1) '1st decimal pt location
AsteriskLoc = InStr(1, InputStr, "*", 1)  ' search flag for approximate values slightly less than xx.xx*
QMLoc = InStr(1, InputStr, "?", 1)  ' search flag for approximate values slightly less than xx.xx?
WCLoc = AsteriskLoc ' Initial WCLoc = Wild Card Loc, could be 0
NoApprox = False

If Not IsNumeric(InputVar) And QMLoc = 0 And AsteriskLoc = 0 Then
MsgBox ("Invalid Format: " & SrchTPI)
Exit Sub
End If

    If IsNumeric(InputVar) Then ' check to see if SrchTPI value is numeric or string
        TPIvalue = Format((InputVar), "###0.00000") ' format to make numeric into search-able string format
        SrchTPIxUp = TPIvalue
    ElseIf (Not IsNumeric(InputVar)) Then ' when text then Plus and Minus searches
        If QMLoc > 0 And AsteriskLoc > 0 And QMLoc <= AsteriskLoc Then WCLoc = QMLoc ' WCLoc=smaller of 1st * or ? location from left side of string
        If QMLoc > 0 And AsteriskLoc = 0 Then WCLoc = QMLoc ' WCLoc=smaller of 1st * or ? location from left side of string
        If WCLoc > 0 Then ' Either "*", "?" or both Wild Cards exists so there is a wild card condition. We do plus and minus searches
            'With a Wwild Card "*" or "?" then we search for approximate values both lower and higher
            'Wild Card = True
            
            
            Dec2AstLoc = WCLoc - DecPtLoc 'find number of char between "." and "*" locations
            'If DecPtLoc = 0 Then Dec2AstLoc = 0  was this needed incase of numbers where * was left of decimal?
            InputStrB4WC = Left(InputStr, WCLoc - 1)
            InputStrPlus = InputStrB4WC & "*"
            InputStrWC = InputStrB4WC & "*"
            InputStr = InputStrWC
        
            Dim InputStrB4WCN As Double ' makes this string into a number
            InputStrB4WCN = InputStrB4WC
            If Dec2AstLoc = 6 Then InputStrMinus = InputStrB4WCN - 0.00001
            If Dec2AstLoc = 5 Then InputStrMinus = InputStrB4WCN - 0.0001
            If Dec2AstLoc = 4 Then InputStrMinus = InputStrB4WCN - 0.001
            If Dec2AstLoc = 3 Then InputStrMinus = InputStrB4WCN - 0.01
            If Dec2AstLoc = 2 Then InputStrMinus = InputStrB4WCN - 0.1
            If Dec2AstLoc = 1 Then InputStrMinus = InputStrB4WCN - 1

                If Dec2AstLoc > 0 Then 'decimal pt location is to the left of the WC location
                    TPIvalueTempMinus = Format((InputStrMinus), "###0.00000") ' format to search-able string format for text search
                    TPIvalueTempPlus = Format((InputStrPlus), "###0.00000") ' format to search-able string format for text search
                    InputStrAF4AstMinus = Left(TPIvalueTempMinus, WCLoc - 1) & "*"
                    InputStrAF4AstPlus = Left(TPIvalueTempPlus, WCLoc - 1) & "*"
                Else
                If Dec2AstLoc = 0 Then 'decimal pt location is = of the WC location? impossible, never happens!
                    InputStrB4WCN = InputStrB4WC & ".0"
                    InputStrMinus = InputStrB4WCN - 0.1
                    InputStrPlus = InputStrB4WCN
                    TPIvalueTempMinus = Format((InputStrMinus), "###0.00000") ' format to search-able string format for text search
                    TPIvalueTempPlus = Format((InputStrPlus), "###0.00000") ' format
                    InputStrAF4AstMinus = Left(TPIvalueTempMinus, WCLoc - 0) & "*"
                    InputStrAF4AstPlus = Left(TPIvalueTempPlus, WCLoc - 1) & ".*"
                End If
                If Dec2AstLoc = -1 Then 'decimal pt location is to the right of the WC location, ie. 3*. becomes
                    InputStrB4WCN = InputStrB4WC & "0."
                    InputStrMinus = InputStrB4WCN - 1
                    InputStrPlus = InputStrB4WCN
                    TPIvalueTempMinus = Format((InputStrMinus), "###0.00000") ' format to search-able string format for text search
                    TPIvalueTempPlus = Format((InputStrPlus), "###0.00000") ' format to search-able string format for text search
                    InputStrAF4AstMinus = Left(TPIvalueTempMinus, WCLoc - 0) & ".*"
                    InputStrAF4AstPlus = Left(TPIvalueTempPlus, WCLoc - 1) & "0.?????"
                End If
                If Dec2AstLoc = -2 Then
                    InputStrB4WCN = InputStrB4WC & "00."
                    InputStrMinus = InputStrB4WCN - 10
                    InputStrPlus = InputStrB4WCN
                    TPIvalueTempMinus = Format((InputStrMinus), "###0.00000") ' format to search-able string format for text search
                    TPIvalueTempPlus = Format((InputStrPlus), "###0.00000") ' format to search-able string format for text search
                    InputStrAF4AstMinus = Left(TPIvalueTempMinus, WCLoc - 0) & "?.*"
                    InputStrAF4AstPlus = Left(TPIvalueTempPlus, WCLoc + 2) & "*"
                End If
                If Dec2AstLoc = -3 Then
                    InputStrB4WCN = InputStrB4WC & "000."
                    InputStrMinus = InputStrB4WCN - 100
                    InputStrPlus = InputStrB4WCN
                    TPIvalueTempMinus = Format((InputStrMinus), "###0.00000") ' format to search-able string format for text search
                    TPIvalueTempPlus = Format((InputStrPlus), "###0.00000") ' format to search-able string format for text search
                    InputStrAF4AstMinus = Left(TPIvalueTempMinus, WCLoc - 0) & "??.*"
                    InputStrAF4AstPlus = Left(TPIvalueTempPlus, WCLoc + 3) & "*"
                End If
            End If
                ' TPI Minus case:
                SrchTPIxDn = InputStrAF4AstMinus
                ' TPI Plus case:
                SrchTPIxUp = InputStrAF4AstPlus
        End If  ' ended + and - searches where there was an "*"" or "?"
    Else
    End If ' end of IsNumeric Else

End Sub
'************************************************************
'************************************************************

