Attribute VB_Name = "Module004_Sort_BySingleCol"
Sub Sort_BySingleCol()
Attribute Sort_BySingleCol.VB_Description = "Key: Ctrl+Shift+B\nSort BY a single column of AllTPI. "
Attribute Sort_BySingleCol.VB_ProcData.VB_Invoke_Func = "B\n14"

' Keyboard Shortcut: Ctrl+Shift+B
' Will allow the user to choose a single column of AllTPI to sort on.  C- will cause a desending sort.
' C or C+ will cause an asending sort.
' No Private subs used

    Dim Xf As Long ' to be the found column number
    Dim Yf As Long  ' to be the found row number
    Dim ShSearch As String  ' User Input: The sheet to be searched
    Dim lRow As Long ' last row number of the data
    Dim lCol As Long ' last column number of the data
    Dim lColi As Long 'the number of columns in the virgin AllTPI
    Dim MsgStr As String  ' long message box string to the user
    Dim DeleteFlagCnt As Long
    Dim DeleteFlagNum As Long
    Dim TotalDeleteRowCnt As Long
    Dim YesNoAnswer As Integer
    Dim SortStartRow As Long
    Dim SortEndRow As Long
    Dim SColumnL As String
    Dim SColumnN As Long
    Dim SColSign As Long
    Dim tmpL As String  'temp to handle letters errors
    Dim tmpR As String  'temp to handle sort order
    Dim iCnt As Long
    Dim iCntMax As Long
    Dim LatheSortOrder As String
    

    ShSearch = "AllTPI"
' Checking to see if the sheet name exists. If not then exits with a message
    YesNoAnswer = 0
    For Each Sheet In ActiveWorkbook.Worksheets
        If Sheet.Name = ShSearch Then
            YesNoAnswer = 1
            Exit For
        Else
        End If
    Next
     If YesNoAnswer = 0 Then
            MsgStr = "There is no " + ShSearch + " sheet to Search, Please run: GenAllTPI"
            MsgBox MsgStr, vbOKOnly, "Missing Sheet"
        Exit Sub
        Else
        End If


    Sheets(ShSearch).Select
    LatheSheetName = Cells(1, 8) 'Retrive the lathe sheet name from the ALLTPI table title
    
    lRow = Cells(Rows.Count, "C").End(xlUp).Row
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
    lColi = lCol   'The initial Column Count
' This tells us how many DELETE FLAG that there are in the column 2 from the top to the bottom of data.
DeleteFlagCnt = Application.WorksheetFunction.CountIf(Range(Cells(1, 2), Cells(lRow, 2)), "DELETE FLAG")
Range("AA1") = DeleteFlagCnt  'Debug

'*************************
'this will find the row number of the last DELETE FLAG if the answer is Yes, it is called the DeleteFlagNum but should be called the DeleteFlagNumRows
    TotalDeleteRowCnt = 0
    If DeleteFlagCnt > 0 Then
        MsgStr = "There has been " + CStr(DeleteFlagCnt) + " previous search(s).  Before sorting, do you wish to keep them?"
        YesNoAnswer = MsgBox(MsgStr, vbQuestion + vbYesNo + vbDefaultButton2, "Keep Previous Searches")
        
        If YesNoAnswer = vbNo Then
            '********* Clean up previous TPI search via deletions
            Call DeleteSrchTopRwsQ ' makes this Subroutine call to removed ONE previous search.
        Else
        End If
    End If
      
'*************************
    If YesNoAnswer = vbYes Then  'keep the rows and count them so as to know the row where to start the sort.
'Count the number of rows from 1 to the last "DELETE FLAG" if anser is yes
        DeleteFlagNum = 0
        Yf = 1
        lRow = Cells(Rows.Count, 3).End(xlUp).Row   ' this is all row including search rows
        
        Do While DeleteFlagNum < DeleteFlagCnt  ' find number of rows holding previous searches
            Stopn = False
            Do While Yf < lRow
                If Cells(Yf, 2) = "DELETE FLAG" Then
                    Stopn = True
                    Yf = Yf + 1
                End If
            Yf = Yf + 1
                If Stopn Then Exit Do
                Stopn = False
            Loop
            DeleteFlagNum = DeleteFlagNum + 1
        Loop
        TotalDeleteRowCnt = Yf - 2 ' new name
    Else
        TotalDeleteRowCnt = 0  ' however it is zero anyway since the delete top rows was run.
        Yf = 0
        lRow = Cells(Rows.Count, 3).End(xlUp).Row
    End If

Range("AA2") = TotalDeleteRowCnt

'*****************************************
' Now start the sort process
   MsgStr = "Please Type the AllTPI Sheet Single Column LETTER that you wish to sort by, A to Z (or a to z). " + _
        "Then add + for Ascending order or - for Descending order, i.e C+ or C- "
    SColumnL = InputBox(MsgStr, _
            "Sort Column LETTER: ", "ORIGINAL_ORDER")
'            "Sort Column number: ", "Your Number Goes Here")
    If SColumnL = "False" Or Len(Trim(SColumnL)) = 0 Then Exit Sub  'This takes care of CANCEL or Null response
' Meaning of SColumnL ~ "Sort Column by a Letter and trailing Sign"
' Working to sort on first letter, but add condition on the second character for ascending or descending order search
    tmpR = Right(SColumnL, 1)
    tmpL = Left(SColumnL, 1)
    SColSign = 1  '  "xlAscending"  ' Default condition is an ascending sort
        If Len(SColumnL) < 2 Then
        SColSign = 1  '  "xlAscending"  ' If only one character then use ascending sort
        ElseIf tmpR = "-" Then
        SColSign = 2  '  "xlDescending"  ' descending sort
        ElseIf tmpR = "+" Then
        SColSign = 1
        Else
    End If
    
    If SColumnL <> "ORIGINAL_ORDER" Then
        If Asc(SColumnL) > 96 Or 123 < Asc(SColumnL) Then 'if lower case letters a through z convert to upper case
            SColumnN = Asc(SColumnL) - (97 - 65)  ' sort column number, converts from lower case to upper case
            SColumnL = Chr(SColumnN)  'New sort column letter in upper case
        Else
            If Asc(SColumnL) < 65 Or 90 < Asc(SColumnL) Then  ' avoid characters except for A through Z
                SColumnL = "A"  ' if the letter is out of range then do a sort on the orignial row numbers.
                SColumnN = Asc(SColumnL) - 64
            Else
            End If
        End If
        SColumnN = Asc(SColumnL) - 64
    Else
        SColumnL = "A"  'If "ORIGINAL_ORDER" is returned then do sort on row numbers.
        SColumnN = Asc(SColumnL) - 64
    End If
    
'**********************************************
'**********************************************
'**********************************************

    SortStartRow = TotalDeleteRowCnt + 2
    SortEndRow = lRow
    
    Range(Cells(SortStartRow, 2), Cells(SortEndRow, lCol)).Select
    ActiveWorkbook.Worksheets("AllTPI").Sort.SortFields.Clear
    ActiveWorkbook.Worksheets("AllTPI").Sort.SortFields.Add Key:=Range( _
        Cells(SortStartRow, SColumnN), Cells(SortEndRow, SColumnN)), SortOn:=xlSortOnValues, Order:=SColSign, DataOption:= _
        xlSortTextAsNumbers
    ActiveWorkbook.Worksheets("AllTPI").Sort.SortFields.Add Key:=Range( _
        Cells(SortStartRow, 16), Cells(SortEndRow, 16)), SortOn:=xlSortOnValues, Order:=SColSign, DataOption:= _
        xlSortTextAsNumbers
    With ActiveWorkbook.Worksheets("AllTPI").Sort
        .SetRange Range(Cells(SortStartRow, 1), Cells(SortEndRow, lCol))
        .Header = xlYes
        .MatchCase = False
        .Orientation = xlTopToBottom
        .SortMethod = xlPinYin
        .Apply
    End With

    SortOrder = SColumnL
    Sheets(LatheSheetName).Cells(5, 1) = SortOrder 'Write to the lathe template the latest sort order
  
    Range(Cells(TotalDeleteRowCnt + 1, 4), Cells(TotalDeleteRowCnt + 1, 4)) = "Sort: "
    Range(Cells(TotalDeleteRowCnt + 1, 5), Cells(TotalDeleteRowCnt + 1, 5)) = SortOrder

    Range("A1").Select

'*****************************************
    ' Delete a few columns at right to clean up scratch pad and to make the new last column a Null value.
    iCnt = 1
    iCntMax = 8
    Columns(lColi + 1 + iCntMax).EntireColumn.Insert
    While iCnt < iCntMax + 1
        Columns(lColi + 1).EntireColumn.Delete
        iCnt = iCnt + 1
    Wend

End Sub



