Attribute VB_Name = "Module004_Sort_Multi_Colmns"
Sub Sort_Multi_Colmns()
Attribute Sort_Multi_Colmns.VB_Description = "Key: Ctrl+Shift+S\nSort_Multiple_Columns defined by the user\n"
Attribute Sort_Multi_Colmns.VB_ProcData.VB_Invoke_Func = "S\n14"
'
' SortAllTPI via all possible columns, user inputs the columns and the search order etc
' Sort_Multiple_Columns defined by the user
' Key: Ctrl Shift + S
' Minor changes

    Dim Xf As Long ' to be the found column number
    Dim Yf As Long  ' to be the found row number
    Dim ShSearch As String  ' User Input: The sheet to be searched
    Dim lColi As Long 'the number of columns in the virgin AllTPI
    Dim MsgStr As String  ' long message box string to the user
    Dim DeleteFlagCnt As Long
    Dim DeleteFlagNum As Long
    Dim TotalDeleteRowCnt As Long
    Dim YesNoAnswer As Integer

    Dim lRow As Long ' last row number of the data
    Dim lCol As Long ' last column number of the data
    Dim SortStartRow As Long
    Dim SortEndRow As Long
    Dim SortOrder As String
    
    Dim SortL() As String
    Dim Lnn As Long
    Dim SortCoLeng As Long
    Dim intI As Long
    Dim curColLet(26) As String
    Dim curColSign(26) As String
    Dim ADOrder As Long
    Dim LatheSheetName As String
    Dim LatheSortOrder As String
    
'***************

    ShSearch = "AllTPI"
' Checking to see if the sheet name exists. If not then exits with a message
    YesNoAnswer = 0
    For Each Sheet In ActiveWorkbook.Worksheets
        If Sheet.Name = ShSearch Then
            YesNoAnswer = 1
            Exit For
        Else
        End If
    Next
     If YesNoAnswer = 0 Then
            MsgStr = "There is no " + ShSearch + " sheet to Search, Please run: GenAllTPI"
            MsgBox MsgStr, vbOKOnly, "Missing Sheet"
        Exit Sub
        Else
        End If

    
    Sheets(ShSearch).Select
    
    LatheSheetName = Cells(1, 8) 'Retrive the lathe sheet name from the ALLTPI table title
    LatheSortOrder = Sheets(LatheSheetName).Cells(4, 1).Value  'Retrive the column sort list from the Lathe Template

    lRow = Cells(Rows.Count, "C").End(xlUp).Row
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
    lColi = lCol   'The initial Column Count
' This tells us how many DELETE FLAG that there are in the column 2 from the top to the bottom of data.
DeleteFlagCnt = Application.WorksheetFunction.CountIf(Range(Cells(1, 2), Cells(lRow, 2)), "DELETE FLAG")
' Range("AA1") = DeleteFlagCnt  'Debug


'*************************
'this will find the row number of the last DELETE FLAG if the answer is Yes, it is called the DeleteFlagNum but should be called the DeleteFlagNumRows
    TotalDeleteRowCnt = 0
    If DeleteFlagCnt > 0 Then
        MsgStr = "There has been " + CStr(DeleteFlagCnt) + " previous search(s).  Before sorting, do you wish to keep them?"
        YesNoAnswer = MsgBox(MsgStr, vbQuestion + vbYesNo + vbDefaultButton2, "Keep Previous Searches")
        
        If YesNoAnswer = vbNo Then
            '********* Clean up previous TPI search via deletions
            Call DeleteSrchTopRwsQ ' makes this Subroutine call to removed ONE previous search.
        Else
        End If
    End If
      
'*************************
    If YesNoAnswer = vbYes Then  'keep the rows and count them so as to know the row where to start the sort.
'Count the number of rows from 1 to the last "DELETE FLAG" if anser is yes
        DeleteFlagNum = 0
        Yf = 1
        lRow = Cells(Rows.Count, 3).End(xlUp).Row   ' this is all row including search rows
        
        Do While DeleteFlagNum < DeleteFlagCnt  ' find number of rows holding previous searches
            Stopn = False
            Do While Yf < lRow
                If Cells(Yf, 2) = "DELETE FLAG" Then
                    Stopn = True
                    Yf = Yf + 1
                End If
            Yf = Yf + 1
                If Stopn Then Exit Do
                Stopn = False
            Loop
            DeleteFlagNum = DeleteFlagNum + 1
        Loop
        TotalDeleteRowCnt = Yf - 2 ' new name
    Else
        TotalDeleteRowCnt = 0  ' however it is zero anyway since the delete top rows was run.
        Yf = 0
        lRow = Cells(Rows.Count, 3).End(xlUp).Row
    End If

' Range("AA2") = TotalDeleteRowCnt ' Debug feature
  
'******************  Sorting Columns and Order Requested
    
    MsgStr = "Provide a Column Sort Order list (Max. # Column letters = 13) plus +(ascending) or -(descending) signs.  Example: K+I+J-L+M-N+O+P+Q+R+S+T- will sort all rows by K then I then J ..etc.  Total # of characters plus the signs must be an even number. The suggested value, below, is retrieved from lathesheet cell 'A4'"
        SortOrder = InputBox(MsgStr, _
            "Sort Ordered Column List", LatheSortOrder)
    If SortOrder = "False" Or Len(Trim(SortOrder)) = 0 Then Exit Sub  'This takes care of CANCEL or Null response
    If (1 - (Len(SortOrder) Mod 2)) = 0 Then Exit Sub  ' This stops if SortOrder length is odd
    
'    Range("I1") = SortOrder  'debug or allows one to see the sort requested

Sheets(LatheSheetName).Cells(5, 1) = SortOrder 'Write to the lathe template the latest sort order

    SortColLeng = Len(SortOrder)
 '   Range("AA3") = SortColLeng  ' Debug, delete
 '   Range("AA4") = Mid(SortOrder, 4, 2) 'Debug, delete, Finds the two characters of string starting at the 4th character.

    For intI = 1 To SortColLeng Step 2
    curColLet(intI) = Mid(SortOrder, intI, 1) ' extract sort column letter
    curColSign(intI) = Mid(SortOrder, intI + 1, 1) 'extract sort column sign
    Next

 '**********************************************
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column  ' the last column in the table at the bottom
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column

    SortStartRow = TotalDeleteRowCnt + 2
    SortEndRow = lRow
 '**********************************************
'  Now do the sort
    Columns("A:Z").Select
    ActiveWorkbook.Worksheets(ShSearch).Sort.SortFields.Clear  ' then defined the sort rows and the order
          
    For intI = 1 To SortColLeng Step 2   'Set up the columns to sort on
        ADOrder = 1  'xlAscending
        If curColSign(intI) = "-" Then ADOrder = 2  'xlDescending

        ActiveWorkbook.Worksheets(ShSearch).Sort.SortFields.Add Key:=Range(curColLet(intI) & SortStartRow & ":" & curColLet(intI) & SortEndRow _
            ), SortOn:=xlSortOnValues, Order:=ADOrder, DataOption:=xlSortTextAsNumbers
    Next
               
    With ActiveWorkbook.Worksheets(ShSearch).Sort  ' Do the actual sorting and place result
        .SetRange Range(Cells(SortStartRow, 1), Cells(SortEndRow, lCol))
        .Header = xlYes
        .MatchCase = False
        .Orientation = xlTopToBottom
        .SortMethod = xlPinYin
        .Apply
    End With
    
    Range(Cells(TotalDeleteRowCnt + 1, 4), Cells(TotalDeleteRowCnt + 1, 4)) = "Sort: "
    Range(Cells(TotalDeleteRowCnt + 1, 5), Cells(TotalDeleteRowCnt + 1, 5)) = SortOrder
    
    Range("B1").Select   ' put the cursor back at the top
End Sub


