Attribute VB_Name = "Module005_UnderLines_Insert"
Sub UnderLines_Insert()
Attribute UnderLines_Insert.VB_Description = "Key: Ctrl+Shift+I\nInsert underlines in the AllTPI sheet table."
Attribute UnderLines_Insert.VB_ProcData.VB_Invoke_Func = "I\n14"
' Program to INSERT demarcation underlines in TPI table
'ShortcutKey: Ctrl+Shift+I
'   calls a number of private subs.

Dim RnumSpace As String
Dim Rnum As Long
Dim lRow As Long
Dim lCol As Long

ShName = "AllTPI"

Call Chk4ShX(ShName, ShExists)
If ShExists = False Then Exit Sub
Sheets(ShName).Select

Call RemoveUnderlinesX(ShName)

Call FindFlagAddressX(ShName, "B", "DELETE FLAG", LastFlagAddress)
Sheets(ShName).Select ' just in case it was changed in the Call
If LastFlagAddress = "None" Then LastFlagAddress = "A0"
InputStrAft1Let = Right(LastFlagAddress, Len(LastFlagAddress) - 1)
StartRow = InputStrAft1Let + 3

lRow = Cells(Rows.Count, "C").End(xlUp).Row
lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
LatheName = Cells(InputStrAft1Let + 1, 8).Value
Sheets(LatheName).Select
I = 1
Cnt2Zzz = 1
FLAG = ""
Do While FLAG <> "Zzz" ' count the number of gears at first lever
    Cnt2Zzz = I
    If I > 100 Then Exit Sub  ' Just in case, limit an error
    FLAG = Cells(30 + I, 9) ' Stepping down looking for Zzz flag
    I = I + 1
Loop

GearRowCnt = lRow - StartRow + 1 ' How many gear rows are there after StartRow

'Insert Row Bottom demarcation lines ~ at the end of each set of gears or every few lines
Worksheets(ShName).Select
Application.DisplayAlerts = True
Application.ScreenUpdating = True

MsgStr = "If You would like to have eye guiding underlines in the TPI table insert a repeat spacing Integer. example: 5,   0=> No Underlines"
    RnumSpace = InputBox(MsgStr, _
        "Provide underline spacing number", CStr(Cnt2Zzz - 1))
If RnumSpace = "False" Or Len(Trim(RnumSpace)) = 0 Then RnumSpace = CStr(Cnt2Zzz - 1)    'This takes care of CANCEL or Null response

Application.ScreenUpdating = False   ' Turns the display off while drawing horizontal lines, saves time.
If RnumSpace <> 0 Then
    'Find the last non-blank cell in TPI column
    lRow = Cells(Rows.Count, 3).End(xlUp).Row
    'Find the last non-blank cell in lRow just found
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
Rnum = StartRow - 1 + RnumSpace
Do While Rnum <= lRow
    With Worksheets(ShName).Range(Cells(Rnum, 1), Cells(Rnum, lCol)).Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = 0
    End With
Rnum = Rnum + RnumSpace  ' Cell bottom demarcation lines at the end of each set of gears
Loop
Else
End If
Application.ScreenUpdating = True  ' Turns the display back on after drawing horizontal lines
Statusinfo = CStr(GearRowCnt) ' Let the User know that something is happening
Statusinfo = "Macro Task Completed-- Total Gears Completed = " + Statusinfo
Application.StatusBar = Statusinfo
Application.DisplayAlerts = True

Cells(InputStrAft1Let + 2, 2) = GearRowCnt ' Total number of gear rows at the top gear row column title row of table
'Range("AB1") = GearRowCnt
End Sub
'****************************************************

'****************************************************
Private Sub Chk4ShX(ShName, ShExists)

' Program to Check for a Sheet's Existance
' Returns a ShExists=True if the sheet exists
' First check to see if a target sheet name was provided and respond:
' If none is provided then Default to AllTPI

' Variables arrive as:
' Dim Srch4Sh As String
' Dim ShExists As Boolean

If ShName = "" Then
    MsgStr = "No Sheet Name was provided!  OK to Default to AllTPI?"
    'MsgBox MsgStr, vbOKOnly
    'MsgBox MsgStr, vbOK, "No Sheet Name Provided"
    MsgBox MsgStr, vbOKCancel + vbDefaultButton2, "No Sheet Name Provided"
    ShName = "AllTPI"
Else
End If

ShExists = False  ' Now check to see if the Sheet Name exists.
For Each Sheet In ActiveWorkbook.Worksheets
    If Sheet.Name = ShName Then
        ShExists = True
        Exit For
    Else
    End If
    Next

If ShExists = 0 Then
    MsgStr = "There is no " + ShName + " sheet. Please correct or select another name."
    MsgBox MsgStr, vbOKOnly, "Missing Sheet"
    Exit Sub
Else
End If ' Message ends

Worksheets(ShName).Select
Range("A1").Select
End Sub
'************************************************

'************************************************
Private Sub RemoveUnderlinesX(ShName2)
'
' RemoveUnderlines Macro
' Ctro+Shift+R Removes the underlines in the AllTPI table
'
' Keyboard Shortcut: Ctrl+Shift+R

'This works well, but
' Calls nothing
' It removes lines even if they are in the searched areas? but
' Doesnt it also remove all underlines and then replaces doubles under captions?
'
    'Dim ShName2 As String  ' User Input: The sheet to be searched
    Dim lRow As Long ' last row number of the data
    Dim lCol As Long ' last column number of the data
    Dim lColi As Long 'the number of columns in the virgin AllTPI
    Dim MsgStr As String  ' long message box string to the user
    Dim I As Long
    Dim LatheSheetName As String
    
    
    Sheets(ShName2).Select
    'LatheSheetName = Cells(1, 8) 'Retrive the lathe sheet name from the ALLTPI table title
    
    lRow = Cells(Rows.Count, "C").End(xlUp).Row
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
    Range(Cells(1, 1), Cells(lRow, lCol)).Select
    'Range("A1:Z506").Select
    Selection.Borders(xlDiagonalDown).LineStyle = xlNone
    Selection.Borders(xlDiagonalUp).LineStyle = xlNone
    Selection.Borders(xlEdgeLeft).LineStyle = xlNone
    Selection.Borders(xlEdgeTop).LineStyle = xlNone
    Selection.Borders(xlEdgeBottom).LineStyle = xlNone
    Selection.Borders(xlEdgeRight).LineStyle = xlNone
    Selection.Borders(xlInsideVertical).LineStyle = xlNone
    Selection.Borders(xlInsideHorizontal).LineStyle = xlNone
        
    I = 1
    Do While I < lRow
        If StrComp(Range(Cells(I, 3), Cells(I, 3)), "TPI") = 0 Then
            Range(Cells(I, 1), Cells(I, lCol)).Select
            Selection.Borders(xlDiagonalDown).LineStyle = xlNone
            Selection.Borders(xlDiagonalUp).LineStyle = xlNone
            Selection.Borders(xlEdgeLeft).LineStyle = xlNone
            Selection.Borders(xlEdgeTop).LineStyle = xlNone
            With Selection.Borders(xlEdgeBottom)
                .LineStyle = xlDouble
                .ColorIndex = 0
                .TintAndShade = 0
                .Weight = xlThick
            End With
            Selection.Borders(xlEdgeRight).LineStyle = xlNone
            Selection.Borders(xlInsideVertical).LineStyle = xlNone
            Selection.Borders(xlInsideHorizontal).LineStyle = xlNone
            
            I = I + 1
        Else
            I = I + 1
        End If
    Loop
      
    'Range("A1").Select

End Sub
'****************************************************

'****************************************************
Private Sub FindFlagAddressX(ShName, SrchCol2, FLAG, LastFlagAddress)

'This works Great.  If finds the address of the last occurance of
'the "DELETE FLAG"
'Nice and short code to yield the cell address

Dim ColRng As Range, where As Range, whatt As String
Sheets(ShName).Select
whatt = FLAG
Set ColRng = Range(SrchCol2 & ":" & SrchCol2)
Set where = ColRng.Find(What:=whatt, after:=ColRng(ColRng.Cells.Count), searchdirection:=xlPrevious)
If Not where Is Nothing Then
    LastFlagAddress = where.Address(0, 0)
Else
    LastFlagAddress = "None"
Exit Sub
End If

End Sub
'****************************************************

'****************************************************


