Attribute VB_Name = "Module005_Underlines_Remove"
Sub Underlines_Remove()
Attribute Underlines_Remove.VB_Description = "Key:  Ctrl+Shift+R\nRemoves the underlines in the AllTPI table"
Attribute Underlines_Remove.VB_ProcData.VB_Invoke_Func = "R\n14"
'
' RemoveUnderlines Macro
' Ctro+Shift+R Removes the underlines in the AllTPI table
'
' Keyboard Shortcut: Ctrl+Shift+R

'This works well, but
' Calls only Private sub Chk4ShX
' It removes lines even if they are in the searched areas?
'
    Dim ShSearch As String  ' User Input: The sheet to be searched
    Dim lRow As Long ' last row number of the data
    Dim lCol As Long ' last column number of the data
    Dim lColi As Long 'the number of columns in the virgin AllTPI
    Dim MsgStr As String  ' long message box string to the user
    Dim I As Long
    Dim LatheSheetName As String
    
    ShSearch = "AllTPI"
' Checking to see if the sheet name exists. If not then exits with a message
ShName = ShSearch
Call Chk4ShX(ShName, ShExists)
If ShExists = False Then Exit Sub

Sheets(ShSearch).Select
    LatheSheetName = Cells(1, 8) 'Retrive the lathe sheet name from the ALLTPI table title
    
    lRow = Cells(Rows.Count, "C").End(xlUp).Row
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
    Range(Cells(1, 1), Cells(lRow, lCol)).Select
    'Range("A1:Z506").Select
    Selection.Borders(xlDiagonalDown).LineStyle = xlNone
    Selection.Borders(xlDiagonalUp).LineStyle = xlNone
    Selection.Borders(xlEdgeLeft).LineStyle = xlNone
    Selection.Borders(xlEdgeTop).LineStyle = xlNone
    Selection.Borders(xlEdgeBottom).LineStyle = xlNone
    Selection.Borders(xlEdgeRight).LineStyle = xlNone
    Selection.Borders(xlInsideVertical).LineStyle = xlNone
    Selection.Borders(xlInsideHorizontal).LineStyle = xlNone
        
    I = 1
    Do While I < lRow
        If StrComp(Range(Cells(I, 3), Cells(I, 3)), "TPI") = 0 Then
            Range(Cells(I, 1), Cells(I, lCol)).Select
            Selection.Borders(xlDiagonalDown).LineStyle = xlNone
            Selection.Borders(xlDiagonalUp).LineStyle = xlNone
            Selection.Borders(xlEdgeLeft).LineStyle = xlNone
            Selection.Borders(xlEdgeTop).LineStyle = xlNone
            With Selection.Borders(xlEdgeBottom)
                .LineStyle = xlDouble
                .ColorIndex = 0
                .TintAndShade = 0
                .Weight = xlThick
            End With
            Selection.Borders(xlEdgeRight).LineStyle = xlNone
            Selection.Borders(xlInsideVertical).LineStyle = xlNone
            Selection.Borders(xlInsideHorizontal).LineStyle = xlNone
            
            I = I + 1
        Else
            I = I + 1
        End If
    Loop
      
    Range("A1").Select

End Sub

'************************************************************

'************************************************************
Private Sub Chk4ShX(ShName, ShExists)

' Program to Check for a Sheet's Existance
' Returns a ShExists=True if the sheet exists
' First check to see if a target sheet name was provided and respond:
' If none is provided then Default to AllTPI

' Variables arrive as:
' Dim Srch4Sh As String
' Dim ShExists As Boolean

If ShName = "" Then
    MsgStr = "No Sheet Name was provided!  OK to Default to AllTPI?"
    'MsgBox MsgStr, vbOKOnly
    'MsgBox MsgStr, vbOK, "No Sheet Name Provided"
    MsgBox MsgStr, vbOKCancel + vbDefaultButton2, "No Sheet Name Provided"
    ShName = "AllTPI"
Else
End If

ShExists = False  ' Now check to see if the Sheet Name exists.
For Each Sheet In ActiveWorkbook.Worksheets
    If Sheet.Name = ShName Then
        ShExists = True
        Exit For
    Else
    End If
    Next

If ShExists = 0 Then
    MsgStr = "There is no " + ShName + " sheet. Please correct or select another name."
    MsgBox MsgStr, vbOKOnly, "Missing Sheet"
    Exit Sub
Else
End If ' Message ends

Worksheets(ShName).Select
Range("A1").Select
End Sub

