Attribute VB_Name = "Module006_CopyPasteTPISrch2List"
Sub CopyPasteTPISrch2List()
Attribute CopyPasteTPISrch2List.VB_Description = "Key: Ctrl+Shift+C\nCopy and Paste the top searched rows from AllTPI to new sheet"
Attribute CopyPasteTPISrch2List.VB_ProcData.VB_Invoke_Func = "C\n14"

'N424 works, copys the top rows of search to a new sheet called SrchdTPI
'Short cut key:  Ctrl+Shift+C

'If SrchdTPI sheet exists then deletes it and creats a new one
'Checks the number of searched results in AllTPI and Copies
'Pastes them to the new sheet with formating and column widths.
'Copy and Transfers the hidden column attributes
' Uses Private Sub FindFlagAddressX(ShSearch, SrchCol, FLAG, LastFlagAddress)

Dim StndSh As String
Dim ShSearch As String
Dim FLAG As String
Dim NewlRow As Long

StndSh = "SrchdTPI"  ' Paste to, SearcheD=Srchd, past tense
ShSearch = "AllTPI"  ' copy from
  
Application.DisplayAlerts = False
For Each Sheet In ActiveWorkbook.Worksheets 'If StndTPI sheet exists delete it
    If Sheet.Name = StndSh Then Sheet.Delete
Next Sheet
Application.DisplayAlerts = True

Sheets.Add(Before:=Sheets(1)).Name = StndSh 'create new sheet at first tab position

Sheets(ShSearch).Select
SrchCol = "B"
FLAG = "DELETE FLAG"
Call FindFlagAddressX(ShSearch, SrchCol, FLAG, LastFlagAddress)

Sheets(ShSearch).Select ' just in case it was changed in the Call
If LastFlagAddress = "None" Then LastFlagAddress = "A0"
InputStrAft1Let = Right(LastFlagAddress, Len(LastFlagAddress) - 1)
LastFlagRow = InputStrAft1Let

lRow = Cells(Rows.Count, "C").End(xlUp).Row
lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
Range(Cells(1, 1), Cells(LastFlagRow + 2, lCol)).Select ' also copy titles at bottom
Selection.Copy   ' copy and paste the found data into the new sheet
Worksheets(StndSh).Select
Cells(1, 1).Select
'Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
    :=False, Transpose:=False
'Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
    SkipBlanks:=False, Transpose:=False
Selection.PasteSpecial Paste:=xlPasteAll, Operation:=xlNone, _
    SkipBlanks:=False, Transpose:=False
Selection.PasteSpecial Paste:=xlPasteColumnWidths, Operation:=xlNone, _
    SkipBlanks:=False, Transpose:=False
      
Sheets(ShSearch).Select
Range("A1").Select  ' after pasting go back and turn off the copy cell highlight
Application.CutCopyMode = False 'remove copied material from Excel Clipboard
Worksheets(StndSh).Select
      
CCol = 1
Do While CCol <= lCol
If Sheets(ShSearch).Columns(CCol).Hidden = True Then Sheets(StndSh).Columns(CCol).Hidden = True
CCol = CCol + 1
Loop

Application.DisplayAlerts = False
Sheets(StndSh).Select
NewlRow = Cells(Rows.Count, "C").End(xlUp).Row
IRow = 1
Do While IRow <= NewlRow ' underline bottom of each TPI group and remove intermediate titles
    RRow = NewlRow - IRow + 1
    If Cells(RRow, 2).Value = FLAG Then
        With Range(Cells(RRow - 1, 1), Cells(RRow - 1, lCol)).Borders(xlEdgeBottom)
            .LineStyle = xlDouble
            .Weight = xlMedium
            .ColorIndex = 0
        End With
        With Range(Cells(RRow, 1), Cells(RRow, lCol)).Borders(xlEdgeBottom)
            .LineStyle = xlDouble
            .Weight = xlMedium
            .ColorIndex = 0
        End With
    End If
    IRow = IRow + 1
Loop

NewlRow = Cells(Rows.Count, "C").End(xlUp).Row

IRow = 1
Do While IRow <= NewlRow ' underline bottom of each TPI group and remove intermediate titles
    RRow = NewlRow - IRow + 1
    If Cells(RRow, 2).Value = FLAG Then Rows(RRow + 2).Delete ' Delete titles two rows below FLAG
    If Cells(RRow, 2).Value = FLAG Then Rows(RRow + 1).Delete ' Delete titles one row below FLAG
    IRow = IRow + 1
Loop


Application.DisplayAlerts = True
Range("A1").Select ' clears the pages from the copy


End Sub

'*************************************
Private Sub FindFlagAddressX(ShSearch, SrchCol, FLAG, LastFlagAddress)

'This works Great.  If finds the address of the last ocurance of
'the "DELETE FLAG"
'Nice and short code to yield the cell address
'From this comes the row number

Dim ColRng As Range, where As Range, whatt As String
SrchCol2 = SrchCol
Sheets(ShSearch).Select
whatt = FLAG
Set ColRng = Range(SrchCol2 & ":" & SrchCol2)
Set where = ColRng.Find(What:=whatt, after:=ColRng(ColRng.Cells.Count), searchdirection:=xlPrevious)
If Not where Is Nothing Then
    LastFlagAddress = where.Address(0, 0)
Else
    LastFlagAddress = "None"
Exit Sub
End If

End Sub

